import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( 2.48878 + (scaled_cement*-0.70158) + (scaled_fine_aggregate*2.57095) + (scaled_coarse_aggregate*2.01892) + (scaled_wc*2.62286) )
		perceptron_layer_1_output_1 = np.tanh( 0.579647 + (scaled_cement*-4.01136) + (scaled_fine_aggregate*-1.85162) + (scaled_coarse_aggregate*-1.21568) + (scaled_wc*-1.82612) )
		perceptron_layer_1_output_2 = np.tanh( 0.794695 + (scaled_cement*3.88401) + (scaled_fine_aggregate*0.705316) + (scaled_coarse_aggregate*0.798616) + (scaled_wc*2.41528) )
		perceptron_layer_1_output_3 = np.tanh( 1.06303 + (scaled_cement*-1.29682) + (scaled_fine_aggregate*0.112388) + (scaled_coarse_aggregate*-2.36114) + (scaled_wc*-1.85744) )
		perceptron_layer_1_output_4 = np.tanh( -1.59157 + (scaled_cement*0.533115) + (scaled_fine_aggregate*-1.16058) + (scaled_coarse_aggregate*-1.12041) + (scaled_wc*-1.54434) )
		perceptron_layer_1_output_5 = np.tanh( -1.42619 + (scaled_cement*2.3254) + (scaled_fine_aggregate*0.260018) + (scaled_coarse_aggregate*1.44217) + (scaled_wc*1.58735) )
		perceptron_layer_1_output_6 = np.tanh( -3.53717 + (scaled_cement*-1.2525) + (scaled_fine_aggregate*0.788113) + (scaled_coarse_aggregate*-0.107868) + (scaled_wc*-4.85113) )
		perceptron_layer_1_output_7 = np.tanh( 0.0588309 + (scaled_cement*-1.13097) + (scaled_fine_aggregate*-0.32144) + (scaled_coarse_aggregate*-0.248171) + (scaled_wc*-0.461808) )
		
		perceptron_layer_2_output_0 = ( 0.369123 + (perceptron_layer_1_output_0*-0.977664) + (perceptron_layer_1_output_1*0.699698) + (perceptron_layer_1_output_2*-0.820875) + (perceptron_layer_1_output_3*-0.340327) + (perceptron_layer_1_output_4*-0.943165) + (perceptron_layer_1_output_5*-0.611329) + (perceptron_layer_1_output_6*0.621375) + (perceptron_layer_1_output_7*-2.46642) )
		
		unscaling_layer_output_0=perceptron_layer_2_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
