import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( 0.0891661 + (scaled_cement*-1.48133) + (scaled_fine_aggregate*-0.222219) + (scaled_coarse_aggregate*-0.411284) + (scaled_wc*0.810063) )
		perceptron_layer_1_output_1 = np.tanh( -0.0484912 + (scaled_cement*1.41787) + (scaled_fine_aggregate*0.608894) + (scaled_coarse_aggregate*-0.233561) + (scaled_wc*0.778867) )
		perceptron_layer_1_output_2 = np.tanh( -0.721846 + (scaled_cement*-3.41038) + (scaled_fine_aggregate*-0.595267) + (scaled_coarse_aggregate*-0.783042) + (scaled_wc*-2.18475) )
		perceptron_layer_1_output_3 = np.tanh( 0.832393 + (scaled_cement*-2.4906) + (scaled_fine_aggregate*-2.10117) + (scaled_coarse_aggregate*-1.02883) + (scaled_wc*-0.9972) )
		perceptron_layer_1_output_4 = np.tanh( -0.858214 + (scaled_cement*-2.53654) + (scaled_fine_aggregate*-0.372345) + (scaled_coarse_aggregate*-0.937307) + (scaled_wc*-1.51495) )
		perceptron_layer_1_output_5 = np.tanh( -2.26614 + (scaled_cement*-0.066902) + (scaled_fine_aggregate*0.150025) + (scaled_coarse_aggregate*-0.146917) + (scaled_wc*-2.12516) )
		perceptron_layer_1_output_6 = np.tanh( -1.44398 + (scaled_cement*1.02984) + (scaled_fine_aggregate*-2.11807) + (scaled_coarse_aggregate*-1.33806) + (scaled_wc*-1.17787) )
		perceptron_layer_1_output_7 = np.tanh( -1.2152 + (scaled_cement*-0.18924) + (scaled_fine_aggregate*1.54118) + (scaled_coarse_aggregate*0.966123) + (scaled_wc*-1.96482) )
		
		perceptron_layer_2_output_0 = ( 0.373749 + (perceptron_layer_1_output_0*0.0809031) + (perceptron_layer_1_output_1*0.62885) + (perceptron_layer_1_output_2*1.5799) + (perceptron_layer_1_output_3*0.460699) + (perceptron_layer_1_output_4*-1.45346) + (perceptron_layer_1_output_5*0.469578) + (perceptron_layer_1_output_6*0.316212) + (perceptron_layer_1_output_7*0.495101) )
		
		unscaling_layer_output_0=perceptron_layer_2_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
