import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -1.86616 + (scaled_cement*-2.02124) + (scaled_fine_aggregate*0.791959) + (scaled_coarse_aggregate*0.440075) + (scaled_wc*-3.265) )
		perceptron_layer_1_output_1 = np.tanh( 1.11846 + (scaled_cement*0.188049) + (scaled_fine_aggregate*2.05524) + (scaled_coarse_aggregate*2.513) + (scaled_wc*1.40224) )
		perceptron_layer_1_output_2 = np.tanh( -0.55001 + (scaled_cement*3.05629) + (scaled_fine_aggregate*1.68815) + (scaled_coarse_aggregate*1.28488) + (scaled_wc*1.23939) )
		perceptron_layer_1_output_3 = np.tanh( -0.231049 + (scaled_cement*0.254248) + (scaled_fine_aggregate*0.168793) + (scaled_coarse_aggregate*0.0936195) + (scaled_wc*0.060649) )
		perceptron_layer_1_output_4 = np.tanh( 0.020912 + (scaled_cement*0.155916) + (scaled_fine_aggregate*0.688233) + (scaled_coarse_aggregate*0.0904093) + (scaled_wc*0.740188) )
		perceptron_layer_1_output_5 = np.tanh( 0.0382955 + (scaled_cement*-0.7265) + (scaled_fine_aggregate*-0.353039) + (scaled_coarse_aggregate*-1.41435) + (scaled_wc*-1.04426) )
		perceptron_layer_1_output_6 = np.tanh( 0.125666 + (scaled_cement*-1.07375) + (scaled_fine_aggregate*-0.952324) + (scaled_coarse_aggregate*-0.510651) + (scaled_wc*-0.0482262) )
		perceptron_layer_1_output_7 = np.tanh( -1.26938 + (scaled_cement*0.394491) + (scaled_fine_aggregate*0.286194) + (scaled_coarse_aggregate*-0.117099) + (scaled_wc*-0.554905) )
		
		perceptron_layer_2_output_0 = ( 0.760941 + (perceptron_layer_1_output_0*0.301929) + (perceptron_layer_1_output_1*-0.351721) + (perceptron_layer_1_output_2*-0.953152) + (perceptron_layer_1_output_3*-0.00703732) + (perceptron_layer_1_output_4*-0.347725) + (perceptron_layer_1_output_5*-0.428544) + (perceptron_layer_1_output_6*-0.849955) + (perceptron_layer_1_output_7*0.89835) )
		
		unscaling_layer_output_0=perceptron_layer_2_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
