import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -1.43798 + (scaled_cement*1.46755) + (scaled_fine_aggregate*2.05426) + (scaled_coarse_aggregate*0.318884) + (scaled_wc*2.42372) )
		perceptron_layer_1_output_1 = np.tanh( 1.03634 + (scaled_cement*-1.69721) + (scaled_fine_aggregate*-1.23393) + (scaled_coarse_aggregate*-0.884994) + (scaled_wc*0.917225) )
		perceptron_layer_1_output_2 = np.tanh( -1.38138 + (scaled_cement*3.94176) + (scaled_fine_aggregate*2.19592) + (scaled_coarse_aggregate*2.13569) + (scaled_wc*0.955545) )
		perceptron_layer_1_output_3 = np.tanh( 1.56506 + (scaled_cement*3.87729) + (scaled_fine_aggregate*0.0184493) + (scaled_coarse_aggregate*-0.180789) + (scaled_wc*1.91741) )
		perceptron_layer_1_output_4 = np.tanh( -3.29526 + (scaled_cement*-1.10626) + (scaled_fine_aggregate*0.456015) + (scaled_coarse_aggregate*-0.437679) + (scaled_wc*-4.47657) )
		perceptron_layer_1_output_5 = np.tanh( 3.67001 + (scaled_cement*-1.80436) + (scaled_fine_aggregate*2.28864) + (scaled_coarse_aggregate*1.15141) + (scaled_wc*2.1744) )
		perceptron_layer_1_output_6 = np.tanh( -0.704195 + (scaled_cement*-1.20053) + (scaled_fine_aggregate*-0.370871) + (scaled_coarse_aggregate*-1.34713) + (scaled_wc*-1.99508) )
		perceptron_layer_1_output_7 = np.tanh( -0.890128 + (scaled_cement*-0.821521) + (scaled_fine_aggregate*0.222617) + (scaled_coarse_aggregate*-1.11257) + (scaled_wc*2.08246) )
		
		perceptron_layer_2_output_0 = np.tanh( 0.230098 + (perceptron_layer_1_output_0*1.13223) + (perceptron_layer_1_output_1*-0.676751) + (perceptron_layer_1_output_2*-1.50614) + (perceptron_layer_1_output_3*-1.29155) + (perceptron_layer_1_output_4*1.57724) + (perceptron_layer_1_output_5*-0.504619) + (perceptron_layer_1_output_6*-1.68865) + (perceptron_layer_1_output_7*-1.42139) )
		perceptron_layer_2_output_1 = np.tanh( -0.621632 + (perceptron_layer_1_output_0*-0.241881) + (perceptron_layer_1_output_1*0.483522) + (perceptron_layer_1_output_2*0.323489) + (perceptron_layer_1_output_3*0.87896) + (perceptron_layer_1_output_4*-0.0265039) + (perceptron_layer_1_output_5*1.12938) + (perceptron_layer_1_output_6*1.12148) + (perceptron_layer_1_output_7*0.890544) )
		perceptron_layer_2_output_2 = np.tanh( -1.00825 + (perceptron_layer_1_output_0*1.45927) + (perceptron_layer_1_output_1*-0.92941) + (perceptron_layer_1_output_2*0.825251) + (perceptron_layer_1_output_3*1.45103) + (perceptron_layer_1_output_4*-0.355716) + (perceptron_layer_1_output_5*1.49369) + (perceptron_layer_1_output_6*-0.873925) + (perceptron_layer_1_output_7*1.04742) )
		perceptron_layer_2_output_3 = np.tanh( -2.45751 + (perceptron_layer_1_output_0*-0.580943) + (perceptron_layer_1_output_1*-0.530044) + (perceptron_layer_1_output_2*1.15447) + (perceptron_layer_1_output_3*0.83767) + (perceptron_layer_1_output_4*-0.214743) + (perceptron_layer_1_output_5*-1.57233) + (perceptron_layer_1_output_6*0.533573) + (perceptron_layer_1_output_7*0.773811) )
		perceptron_layer_2_output_4 = np.tanh( -1.17105 + (perceptron_layer_1_output_0*-0.525887) + (perceptron_layer_1_output_1*0.430402) + (perceptron_layer_1_output_2*-0.960344) + (perceptron_layer_1_output_3*0.140835) + (perceptron_layer_1_output_4*0.222056) + (perceptron_layer_1_output_5*3.07113) + (perceptron_layer_1_output_6*0.211767) + (perceptron_layer_1_output_7*1.41172) )
		perceptron_layer_2_output_5 = np.tanh( -0.808268 + (perceptron_layer_1_output_0*0.226462) + (perceptron_layer_1_output_1*1.24099) + (perceptron_layer_1_output_2*0.195839) + (perceptron_layer_1_output_3*-0.425756) + (perceptron_layer_1_output_4*0.0683752) + (perceptron_layer_1_output_5*0.591052) + (perceptron_layer_1_output_6*0.507126) + (perceptron_layer_1_output_7*0.483821) )
		perceptron_layer_2_output_6 = np.tanh( -0.444673 + (perceptron_layer_1_output_0*1.28667) + (perceptron_layer_1_output_1*-0.224444) + (perceptron_layer_1_output_2*-0.330531) + (perceptron_layer_1_output_3*-0.138386) + (perceptron_layer_1_output_4*0.80806) + (perceptron_layer_1_output_5*-1.32682) + (perceptron_layer_1_output_6*-1.25464) + (perceptron_layer_1_output_7*-0.470733) )
		perceptron_layer_2_output_7 = np.tanh( -0.301955 + (perceptron_layer_1_output_0*-0.204696) + (perceptron_layer_1_output_1*0.576646) + (perceptron_layer_1_output_2*-0.972586) + (perceptron_layer_1_output_3*-0.136446) + (perceptron_layer_1_output_4*-1.25601) + (perceptron_layer_1_output_5*0.987139) + (perceptron_layer_1_output_6*-2.24479) + (perceptron_layer_1_output_7*0.381302) )
		
		perceptron_layer_3_output_0 = ( 0.725888 + (perceptron_layer_2_output_0*1.86691) + (perceptron_layer_2_output_1*1.79272) + (perceptron_layer_2_output_2*-0.414071) + (perceptron_layer_2_output_3*1.3815) + (perceptron_layer_2_output_4*-1.05413) + (perceptron_layer_2_output_5*-0.53857) + (perceptron_layer_2_output_6*-1.10386) + (perceptron_layer_2_output_7*0.843541) )
		
		unscaling_layer_output_0=perceptron_layer_3_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
