import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -0.241371 + (scaled_cement*-0.904986) + (scaled_fine_aggregate*-0.00300834) + (scaled_coarse_aggregate*0.0755827) + (scaled_wc*-1.92354) )
		perceptron_layer_1_output_1 = np.tanh( 1.57623 + (scaled_cement*-0.235053) + (scaled_fine_aggregate*-0.303972) + (scaled_coarse_aggregate*-2.15143) + (scaled_wc*1.81653) )
		perceptron_layer_1_output_2 = np.tanh( 1.0371 + (scaled_cement*-2.31955) + (scaled_fine_aggregate*-2.87111) + (scaled_coarse_aggregate*-0.674144) + (scaled_wc*0.648426) )
		perceptron_layer_1_output_3 = np.tanh( 1.3377 + (scaled_cement*0.578318) + (scaled_fine_aggregate*0.669336) + (scaled_coarse_aggregate*-0.353054) + (scaled_wc*2.28144) )
		perceptron_layer_1_output_4 = np.tanh( -1.75165 + (scaled_cement*-2.7851) + (scaled_fine_aggregate*1.23568) + (scaled_coarse_aggregate*0.472376) + (scaled_wc*-2.25327) )
		perceptron_layer_1_output_5 = np.tanh( -1.93609 + (scaled_cement*3.46849) + (scaled_fine_aggregate*2.49058) + (scaled_coarse_aggregate*3.67966) + (scaled_wc*-0.417458) )
		perceptron_layer_1_output_6 = np.tanh( 1.49202 + (scaled_cement*-1.94957) + (scaled_fine_aggregate*0.671524) + (scaled_coarse_aggregate*0.453243) + (scaled_wc*-0.0815228) )
		perceptron_layer_1_output_7 = np.tanh( -0.85309 + (scaled_cement*0.285442) + (scaled_fine_aggregate*1.27218) + (scaled_coarse_aggregate*0.711149) + (scaled_wc*-1.35138) )
		
		perceptron_layer_2_output_0 = np.tanh( -0.560541 + (perceptron_layer_1_output_0*-1.99258) + (perceptron_layer_1_output_1*-0.432788) + (perceptron_layer_1_output_2*-1.32495) + (perceptron_layer_1_output_3*0.599283) + (perceptron_layer_1_output_4*-2.37142) + (perceptron_layer_1_output_5*0.246152) + (perceptron_layer_1_output_6*-0.426208) + (perceptron_layer_1_output_7*0.624243) )
		perceptron_layer_2_output_1 = np.tanh( -1.95774 + (perceptron_layer_1_output_0*0.325098) + (perceptron_layer_1_output_1*1.50562) + (perceptron_layer_1_output_2*-0.180044) + (perceptron_layer_1_output_3*-2.35986) + (perceptron_layer_1_output_4*1.10059) + (perceptron_layer_1_output_5*-0.937952) + (perceptron_layer_1_output_6*-0.663883) + (perceptron_layer_1_output_7*2.49076) )
		perceptron_layer_2_output_2 = np.tanh( -2.15131 + (perceptron_layer_1_output_0*-0.734461) + (perceptron_layer_1_output_1*0.200526) + (perceptron_layer_1_output_2*-2.14856) + (perceptron_layer_1_output_3*1.00505) + (perceptron_layer_1_output_4*-1.39413) + (perceptron_layer_1_output_5*0.818856) + (perceptron_layer_1_output_6*2.71447) + (perceptron_layer_1_output_7*0.888561) )
		perceptron_layer_2_output_3 = np.tanh( -0.476539 + (perceptron_layer_1_output_0*-0.604205) + (perceptron_layer_1_output_1*0.173155) + (perceptron_layer_1_output_2*1.21594) + (perceptron_layer_1_output_3*-0.405033) + (perceptron_layer_1_output_4*0.441277) + (perceptron_layer_1_output_5*-0.489429) + (perceptron_layer_1_output_6*-0.326061) + (perceptron_layer_1_output_7*-0.43076) )
		perceptron_layer_2_output_4 = np.tanh( -0.393097 + (perceptron_layer_1_output_0*0.840693) + (perceptron_layer_1_output_1*0.107299) + (perceptron_layer_1_output_2*0.736192) + (perceptron_layer_1_output_3*-0.937356) + (perceptron_layer_1_output_4*0.465272) + (perceptron_layer_1_output_5*0.115833) + (perceptron_layer_1_output_6*0.339013) + (perceptron_layer_1_output_7*0.1607) )
		perceptron_layer_2_output_5 = np.tanh( -1.00807 + (perceptron_layer_1_output_0*-0.26192) + (perceptron_layer_1_output_1*-0.224452) + (perceptron_layer_1_output_2*0.587303) + (perceptron_layer_1_output_3*0.351544) + (perceptron_layer_1_output_4*1.51308) + (perceptron_layer_1_output_5*0.239851) + (perceptron_layer_1_output_6*1.89222) + (perceptron_layer_1_output_7*1.07634) )
		perceptron_layer_2_output_6 = np.tanh( 1.24756 + (perceptron_layer_1_output_0*-1.88855) + (perceptron_layer_1_output_1*1.56681) + (perceptron_layer_1_output_2*-1.38292) + (perceptron_layer_1_output_3*1.98908) + (perceptron_layer_1_output_4*-1.3896) + (perceptron_layer_1_output_5*0.662447) + (perceptron_layer_1_output_6*-0.642281) + (perceptron_layer_1_output_7*-0.0621398) )
		perceptron_layer_2_output_7 = np.tanh( -1.56519 + (perceptron_layer_1_output_0*0.968105) + (perceptron_layer_1_output_1*-0.271785) + (perceptron_layer_1_output_2*0.32005) + (perceptron_layer_1_output_3*1.29338) + (perceptron_layer_1_output_4*-0.219327) + (perceptron_layer_1_output_5*0.447402) + (perceptron_layer_1_output_6*0.533355) + (perceptron_layer_1_output_7*1.23752) )
		
		perceptron_layer_3_output_0 = ( 0.70675 + (perceptron_layer_2_output_0*-0.702466) + (perceptron_layer_2_output_1*0.881308) + (perceptron_layer_2_output_2*-0.686828) + (perceptron_layer_2_output_3*-0.331411) + (perceptron_layer_2_output_4*-1.83891) + (perceptron_layer_2_output_5*-0.651529) + (perceptron_layer_2_output_6*-1.14809) + (perceptron_layer_2_output_7*0.718846) )
		
		unscaling_layer_output_0=perceptron_layer_3_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
