import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -0.155871 + (scaled_cement*3.37461) + (scaled_fine_aggregate*2.50959) + (scaled_coarse_aggregate*1.8146) + (scaled_wc*0.753774) )
		perceptron_layer_1_output_1 = np.tanh( -1.40217 + (scaled_cement*0.241644) + (scaled_fine_aggregate*-1.76787) + (scaled_coarse_aggregate*-1.06706) + (scaled_wc*-1.67542) )
		perceptron_layer_1_output_2 = np.tanh( 1.81281 + (scaled_cement*-0.739261) + (scaled_fine_aggregate*0.731643) + (scaled_coarse_aggregate*1.42118) + (scaled_wc*0.44417) )
		perceptron_layer_1_output_3 = np.tanh( 0.199698 + (scaled_cement*-1.92487) + (scaled_fine_aggregate*-0.393741) + (scaled_coarse_aggregate*1.803) + (scaled_wc*-0.44533) )
		perceptron_layer_1_output_4 = np.tanh( 1.72701 + (scaled_cement*-1.11964) + (scaled_fine_aggregate*-1.80399) + (scaled_coarse_aggregate*0.79803) + (scaled_wc*-2.81912) )
		perceptron_layer_1_output_5 = np.tanh( 1.32758 + (scaled_cement*-0.463622) + (scaled_fine_aggregate*-2.42736) + (scaled_coarse_aggregate*-1.94159) + (scaled_wc*2.71005) )
		perceptron_layer_1_output_6 = np.tanh( 1.228 + (scaled_cement*0.0266376) + (scaled_fine_aggregate*-0.275165) + (scaled_coarse_aggregate*-0.129877) + (scaled_wc*1.41583) )
		perceptron_layer_1_output_7 = np.tanh( 0.397068 + (scaled_cement*2.77778) + (scaled_fine_aggregate*1.20887) + (scaled_coarse_aggregate*-0.467964) + (scaled_wc*-0.763422) )
		
		perceptron_layer_2_output_0 = np.tanh( 0.556427 + (perceptron_layer_1_output_0*2.37144) + (perceptron_layer_1_output_1*0.155862) + (perceptron_layer_1_output_2*1.09783) + (perceptron_layer_1_output_3*-0.542853) + (perceptron_layer_1_output_4*0.593155) + (perceptron_layer_1_output_5*0.00966437) + (perceptron_layer_1_output_6*-0.199081) + (perceptron_layer_1_output_7*-0.987924) )
		perceptron_layer_2_output_1 = np.tanh( 2.51197 + (perceptron_layer_1_output_0*-0.362145) + (perceptron_layer_1_output_1*0.787728) + (perceptron_layer_1_output_2*-0.531695) + (perceptron_layer_1_output_3*-0.00837481) + (perceptron_layer_1_output_4*2.34063) + (perceptron_layer_1_output_5*0.654323) + (perceptron_layer_1_output_6*-0.359165) + (perceptron_layer_1_output_7*1.75953) )
		perceptron_layer_2_output_2 = np.tanh( -0.585718 + (perceptron_layer_1_output_0*1.23881) + (perceptron_layer_1_output_1*-0.985729) + (perceptron_layer_1_output_2*-1.69388) + (perceptron_layer_1_output_3*0.0743836) + (perceptron_layer_1_output_4*1.67209) + (perceptron_layer_1_output_5*1.51783) + (perceptron_layer_1_output_6*1.32223) + (perceptron_layer_1_output_7*1.3447) )
		perceptron_layer_2_output_3 = np.tanh( -1.89916 + (perceptron_layer_1_output_0*3.41573) + (perceptron_layer_1_output_1*-1.43145) + (perceptron_layer_1_output_2*0.123847) + (perceptron_layer_1_output_3*0.607373) + (perceptron_layer_1_output_4*-0.392244) + (perceptron_layer_1_output_5*2.34781) + (perceptron_layer_1_output_6*1.12843) + (perceptron_layer_1_output_7*2.62524) )
		perceptron_layer_2_output_4 = np.tanh( -0.0957183 + (perceptron_layer_1_output_0*-0.706279) + (perceptron_layer_1_output_1*0.650088) + (perceptron_layer_1_output_2*-0.325131) + (perceptron_layer_1_output_3*0.256258) + (perceptron_layer_1_output_4*-0.147174) + (perceptron_layer_1_output_5*-0.5859) + (perceptron_layer_1_output_6*-0.592409) + (perceptron_layer_1_output_7*-0.517411) )
		perceptron_layer_2_output_5 = np.tanh( 0.376145 + (perceptron_layer_1_output_0*-0.875911) + (perceptron_layer_1_output_1*1.837) + (perceptron_layer_1_output_2*0.412225) + (perceptron_layer_1_output_3*-0.391864) + (perceptron_layer_1_output_4*0.172079) + (perceptron_layer_1_output_5*-0.635025) + (perceptron_layer_1_output_6*0.561564) + (perceptron_layer_1_output_7*-1.51663) )
		perceptron_layer_2_output_6 = np.tanh( 1.85172 + (perceptron_layer_1_output_0*0.451925) + (perceptron_layer_1_output_1*-0.409212) + (perceptron_layer_1_output_2*0.703893) + (perceptron_layer_1_output_3*-0.0788452) + (perceptron_layer_1_output_4*-0.706232) + (perceptron_layer_1_output_5*0.0658673) + (perceptron_layer_1_output_6*1.86762) + (perceptron_layer_1_output_7*0.0475241) )
		perceptron_layer_2_output_7 = np.tanh( 2.43947 + (perceptron_layer_1_output_0*0.825196) + (perceptron_layer_1_output_1*-1.85126) + (perceptron_layer_1_output_2*-0.559824) + (perceptron_layer_1_output_3*0.827373) + (perceptron_layer_1_output_4*-0.0943725) + (perceptron_layer_1_output_5*-0.66198) + (perceptron_layer_1_output_6*-0.928172) + (perceptron_layer_1_output_7*-1.19767) )
		
		perceptron_layer_3_output_0 = ( 0.402923 + (perceptron_layer_2_output_0*0.688585) + (perceptron_layer_2_output_1*0.648802) + (perceptron_layer_2_output_2*-0.915857) + (perceptron_layer_2_output_3*-0.935532) + (perceptron_layer_2_output_4*-0.699528) + (perceptron_layer_2_output_5*-0.77179) + (perceptron_layer_2_output_6*-0.856736) + (perceptron_layer_2_output_7*-1.05641) )
		
		unscaling_layer_output_0=perceptron_layer_3_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
