import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -1.80649 + (scaled_cement*4.17391) + (scaled_fine_aggregate*1.88901) + (scaled_coarse_aggregate*1.65076) + (scaled_wc*1.59488) )
		perceptron_layer_1_output_1 = np.tanh( -1.67916 + (scaled_cement*-0.226193) + (scaled_fine_aggregate*-1.1179) + (scaled_coarse_aggregate*-0.130168) + (scaled_wc*-2.05705) )
		perceptron_layer_1_output_2 = np.tanh( 0.564913 + (scaled_cement*3.12281) + (scaled_fine_aggregate*0.99704) + (scaled_coarse_aggregate*0.0268501) + (scaled_wc*-1.87732) )
		perceptron_layer_1_output_3 = np.tanh( 1.04406 + (scaled_cement*0.0728964) + (scaled_fine_aggregate*-1.01095) + (scaled_coarse_aggregate*-0.758937) + (scaled_wc*1.61794) )
		perceptron_layer_1_output_4 = np.tanh( 0.38256 + (scaled_cement*1.809) + (scaled_fine_aggregate*-2.94767) + (scaled_coarse_aggregate*0.648671) + (scaled_wc*-1.82432) )
		perceptron_layer_1_output_5 = np.tanh( -0.956517 + (scaled_cement*0.594473) + (scaled_fine_aggregate*-0.302552) + (scaled_coarse_aggregate*-0.512806) + (scaled_wc*1.78439) )
		perceptron_layer_1_output_6 = np.tanh( 0.782311 + (scaled_cement*-0.850267) + (scaled_fine_aggregate*0.250533) + (scaled_coarse_aggregate*1.68082) + (scaled_wc*3.87472) )
		perceptron_layer_1_output_7 = np.tanh( -1.52043 + (scaled_cement*0.624876) + (scaled_fine_aggregate*-0.000969497) + (scaled_coarse_aggregate*-1.14597) + (scaled_wc*-1.00901) )
		
		perceptron_layer_2_output_0 = np.tanh( 0.338252 + (perceptron_layer_1_output_0*1.65652) + (perceptron_layer_1_output_1*-3.85675) + (perceptron_layer_1_output_2*1.22204) + (perceptron_layer_1_output_3*2.73749) + (perceptron_layer_1_output_4*2.29372) + (perceptron_layer_1_output_5*1.34612) + (perceptron_layer_1_output_6*-1.02822) + (perceptron_layer_1_output_7*-1.2202) )
		perceptron_layer_2_output_1 = np.tanh( 0.475735 + (perceptron_layer_1_output_0*-0.820915) + (perceptron_layer_1_output_1*0.824634) + (perceptron_layer_1_output_2*0.68083) + (perceptron_layer_1_output_3*0.826243) + (perceptron_layer_1_output_4*-0.652891) + (perceptron_layer_1_output_5*0.403044) + (perceptron_layer_1_output_6*1.2944) + (perceptron_layer_1_output_7*1.47617) )
		perceptron_layer_2_output_2 = np.tanh( -0.358668 + (perceptron_layer_1_output_0*2.64001) + (perceptron_layer_1_output_1*-2.20935) + (perceptron_layer_1_output_2*0.866526) + (perceptron_layer_1_output_3*1.83878) + (perceptron_layer_1_output_4*-0.690102) + (perceptron_layer_1_output_5*1.92051) + (perceptron_layer_1_output_6*0.0361291) + (perceptron_layer_1_output_7*0.617736) )
		perceptron_layer_2_output_3 = np.tanh( 1.54433 + (perceptron_layer_1_output_0*-0.548306) + (perceptron_layer_1_output_1*-2.02762) + (perceptron_layer_1_output_2*-0.0423405) + (perceptron_layer_1_output_3*1.31614) + (perceptron_layer_1_output_4*0.866722) + (perceptron_layer_1_output_5*0.585512) + (perceptron_layer_1_output_6*-0.403477) + (perceptron_layer_1_output_7*-1.11979) )
		perceptron_layer_2_output_4 = np.tanh( 0.401261 + (perceptron_layer_1_output_0*0.675802) + (perceptron_layer_1_output_1*-3.05402) + (perceptron_layer_1_output_2*2.16393) + (perceptron_layer_1_output_3*2.45116) + (perceptron_layer_1_output_4*1.79524) + (perceptron_layer_1_output_5*0.693528) + (perceptron_layer_1_output_6*0.538615) + (perceptron_layer_1_output_7*-0.611217) )
		perceptron_layer_2_output_5 = np.tanh( 1.02569 + (perceptron_layer_1_output_0*2.58399) + (perceptron_layer_1_output_1*0.176429) + (perceptron_layer_1_output_2*1.07095) + (perceptron_layer_1_output_3*-2.04201) + (perceptron_layer_1_output_4*-1.34926) + (perceptron_layer_1_output_5*-0.683757) + (perceptron_layer_1_output_6*0.104981) + (perceptron_layer_1_output_7*-2.48949) )
		perceptron_layer_2_output_6 = np.tanh( -1.80254 + (perceptron_layer_1_output_0*0.0907801) + (perceptron_layer_1_output_1*0.00952478) + (perceptron_layer_1_output_2*-1.85329) + (perceptron_layer_1_output_3*0.46919) + (perceptron_layer_1_output_4*-0.433496) + (perceptron_layer_1_output_5*0.507369) + (perceptron_layer_1_output_6*0.917878) + (perceptron_layer_1_output_7*1.01309) )
		perceptron_layer_2_output_7 = np.tanh( -0.61914 + (perceptron_layer_1_output_0*0.726861) + (perceptron_layer_1_output_1*-1.52466) + (perceptron_layer_1_output_2*1.0656) + (perceptron_layer_1_output_3*2.19989) + (perceptron_layer_1_output_4*-1.44908) + (perceptron_layer_1_output_5*2.66384) + (perceptron_layer_1_output_6*0.0853478) + (perceptron_layer_1_output_7*1.7849) )
		
		perceptron_layer_3_output_0 = np.tanh( -0.0537332 + (perceptron_layer_2_output_0*0.880972) + (perceptron_layer_2_output_1*0.0722732) + (perceptron_layer_2_output_2*0.257658) + (perceptron_layer_2_output_3*1.12308) + (perceptron_layer_2_output_4*-0.182693) + (perceptron_layer_2_output_5*-0.185789) + (perceptron_layer_2_output_6*0.654325) + (perceptron_layer_2_output_7*-0.0474491) )
		perceptron_layer_3_output_1 = np.tanh( -0.109589 + (perceptron_layer_2_output_0*-0.708292) + (perceptron_layer_2_output_1*0.00714701) + (perceptron_layer_2_output_2*0.132294) + (perceptron_layer_2_output_3*-0.227536) + (perceptron_layer_2_output_4*-0.259582) + (perceptron_layer_2_output_5*-0.214312) + (perceptron_layer_2_output_6*-0.149044) + (perceptron_layer_2_output_7*0.529607) )
		perceptron_layer_3_output_2 = np.tanh( -0.598693 + (perceptron_layer_2_output_0*-1.56352) + (perceptron_layer_2_output_1*-1.20429) + (perceptron_layer_2_output_2*0.578069) + (perceptron_layer_2_output_3*-1.44357) + (perceptron_layer_2_output_4*1.88673) + (perceptron_layer_2_output_5*-1.22908) + (perceptron_layer_2_output_6*-0.685626) + (perceptron_layer_2_output_7*0.53871) )
		perceptron_layer_3_output_3 = np.tanh( 0.521569 + (perceptron_layer_2_output_0*-1.54599) + (perceptron_layer_2_output_1*-0.920814) + (perceptron_layer_2_output_2*-2.82945) + (perceptron_layer_2_output_3*-1.10029) + (perceptron_layer_2_output_4*0.0466208) + (perceptron_layer_2_output_5*-0.28756) + (perceptron_layer_2_output_6*0.745166) + (perceptron_layer_2_output_7*2.7988) )
		perceptron_layer_3_output_4 = np.tanh( 0.555598 + (perceptron_layer_2_output_0*-0.778897) + (perceptron_layer_2_output_1*-0.838363) + (perceptron_layer_2_output_2*0.615268) + (perceptron_layer_2_output_3*-0.485497) + (perceptron_layer_2_output_4*-0.0670921) + (perceptron_layer_2_output_5*-0.140103) + (perceptron_layer_2_output_6*-0.68891) + (perceptron_layer_2_output_7*0.371831) )
		perceptron_layer_3_output_5 = np.tanh( -0.153639 + (perceptron_layer_2_output_0*0.304769) + (perceptron_layer_2_output_1*-0.102441) + (perceptron_layer_2_output_2*0.309637) + (perceptron_layer_2_output_3*0.513757) + (perceptron_layer_2_output_4*-0.738641) + (perceptron_layer_2_output_5*0.795807) + (perceptron_layer_2_output_6*1.06244) + (perceptron_layer_2_output_7*-0.485778) )
		perceptron_layer_3_output_6 = np.tanh( -0.087042 + (perceptron_layer_2_output_0*1.19566) + (perceptron_layer_2_output_1*-0.142435) + (perceptron_layer_2_output_2*0.0108641) + (perceptron_layer_2_output_3*0.87779) + (perceptron_layer_2_output_4*0.785159) + (perceptron_layer_2_output_5*-0.274833) + (perceptron_layer_2_output_6*0.446339) + (perceptron_layer_2_output_7*-0.402132) )
		perceptron_layer_3_output_7 = np.tanh( -0.483904 + (perceptron_layer_2_output_0*-0.734691) + (perceptron_layer_2_output_1*-0.550811) + (perceptron_layer_2_output_2*0.195492) + (perceptron_layer_2_output_3*-0.653608) + (perceptron_layer_2_output_4*0.00543919) + (perceptron_layer_2_output_5*-0.596967) + (perceptron_layer_2_output_6*-1.36348) + (perceptron_layer_2_output_7*0.831955) )
		
		perceptron_layer_4_output_0 = ( 0.787411 + (perceptron_layer_3_output_0*-0.34048) + (perceptron_layer_3_output_1*-0.521247) + (perceptron_layer_3_output_2*1.54095) + (perceptron_layer_3_output_3*1.99466) + (perceptron_layer_3_output_4*0.587803) + (perceptron_layer_3_output_5*-0.70452) + (perceptron_layer_3_output_6*0.83119) + (perceptron_layer_3_output_7*-1.29365) )
		
		unscaling_layer_output_0=perceptron_layer_4_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
