import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -0.979417 + (scaled_cement*-0.849151) + (scaled_fine_aggregate*-1.25735) + (scaled_coarse_aggregate*-0.995755) + (scaled_wc*0.990202) )
		perceptron_layer_1_output_1 = np.tanh( -0.801642 + (scaled_cement*-1.62485) + (scaled_fine_aggregate*-1.8071) + (scaled_coarse_aggregate*-0.330591) + (scaled_wc*-1.07476) )
		perceptron_layer_1_output_2 = np.tanh( -0.926379 + (scaled_cement*-3.86835) + (scaled_fine_aggregate*-0.29174) + (scaled_coarse_aggregate*-0.224967) + (scaled_wc*-2.86505) )
		perceptron_layer_1_output_3 = np.tanh( 1.77561 + (scaled_cement*0.234493) + (scaled_fine_aggregate*-0.768128) + (scaled_coarse_aggregate*0.0712098) + (scaled_wc*1.88856) )
		perceptron_layer_1_output_4 = np.tanh( -1.25053 + (scaled_cement*-3.36421) + (scaled_fine_aggregate*-0.142506) + (scaled_coarse_aggregate*1.25406) + (scaled_wc*1.77598) )
		perceptron_layer_1_output_5 = np.tanh( 1.0944 + (scaled_cement*-0.927512) + (scaled_fine_aggregate*1.37746) + (scaled_coarse_aggregate*-0.00977606) + (scaled_wc*0.178979) )
		perceptron_layer_1_output_6 = np.tanh( 0.631863 + (scaled_cement*2.05895) + (scaled_fine_aggregate*-1.34277) + (scaled_coarse_aggregate*-0.372023) + (scaled_wc*3.79284) )
		perceptron_layer_1_output_7 = np.tanh( 1.1225 + (scaled_cement*-0.664706) + (scaled_fine_aggregate*2.05214) + (scaled_coarse_aggregate*1.20993) + (scaled_wc*1.07484) )
		
		perceptron_layer_2_output_0 = np.tanh( 0.647746 + (perceptron_layer_1_output_0*-1.86476) + (perceptron_layer_1_output_1*0.322077) + (perceptron_layer_1_output_2*0.391601) + (perceptron_layer_1_output_3*-2.89238) + (perceptron_layer_1_output_4*2.01705) + (perceptron_layer_1_output_5*-1.68783) + (perceptron_layer_1_output_6*-0.642554) + (perceptron_layer_1_output_7*-0.323178) )
		perceptron_layer_2_output_1 = np.tanh( 0.0726912 + (perceptron_layer_1_output_0*0.018868) + (perceptron_layer_1_output_1*0.322932) + (perceptron_layer_1_output_2*-2.99139) + (perceptron_layer_1_output_3*0.84999) + (perceptron_layer_1_output_4*-0.422627) + (perceptron_layer_1_output_5*0.588115) + (perceptron_layer_1_output_6*1.69419) + (perceptron_layer_1_output_7*0.158143) )
		perceptron_layer_2_output_2 = np.tanh( 0.43698 + (perceptron_layer_1_output_0*1.29144) + (perceptron_layer_1_output_1*0.773034) + (perceptron_layer_1_output_2*2.75562) + (perceptron_layer_1_output_3*0.72388) + (perceptron_layer_1_output_4*0.191877) + (perceptron_layer_1_output_5*2.37505) + (perceptron_layer_1_output_6*-0.827639) + (perceptron_layer_1_output_7*1.61976) )
		perceptron_layer_2_output_3 = np.tanh( 0.487825 + (perceptron_layer_1_output_0*-1.42627) + (perceptron_layer_1_output_1*4.00954) + (perceptron_layer_1_output_2*1.82608) + (perceptron_layer_1_output_3*0.751145) + (perceptron_layer_1_output_4*0.0461545) + (perceptron_layer_1_output_5*0.706265) + (perceptron_layer_1_output_6*1.70699) + (perceptron_layer_1_output_7*-1.13166) )
		perceptron_layer_2_output_4 = np.tanh( -0.104467 + (perceptron_layer_1_output_0*-1.24987) + (perceptron_layer_1_output_1*1.85763) + (perceptron_layer_1_output_2*-2.02875) + (perceptron_layer_1_output_3*-0.935901) + (perceptron_layer_1_output_4*-0.0697244) + (perceptron_layer_1_output_5*-0.981209) + (perceptron_layer_1_output_6*0.188047) + (perceptron_layer_1_output_7*1.61321) )
		perceptron_layer_2_output_5 = np.tanh( 2.02868 + (perceptron_layer_1_output_0*0.692209) + (perceptron_layer_1_output_1*0.329964) + (perceptron_layer_1_output_2*-0.124846) + (perceptron_layer_1_output_3*1.17528) + (perceptron_layer_1_output_4*-1.00803) + (perceptron_layer_1_output_5*-1.70367) + (perceptron_layer_1_output_6*-0.435147) + (perceptron_layer_1_output_7*-0.462485) )
		perceptron_layer_2_output_6 = np.tanh( -0.151355 + (perceptron_layer_1_output_0*-1.57932) + (perceptron_layer_1_output_1*1.41467) + (perceptron_layer_1_output_2*1.15962) + (perceptron_layer_1_output_3*-1.81366) + (perceptron_layer_1_output_4*1.35752) + (perceptron_layer_1_output_5*-1.35614) + (perceptron_layer_1_output_6*-1.78672) + (perceptron_layer_1_output_7*-1.26136) )
		perceptron_layer_2_output_7 = np.tanh( 1.59131 + (perceptron_layer_1_output_0*1.85543) + (perceptron_layer_1_output_1*1.98353) + (perceptron_layer_1_output_2*-0.17835) + (perceptron_layer_1_output_3*0.613586) + (perceptron_layer_1_output_4*1.15441) + (perceptron_layer_1_output_5*-1.04377) + (perceptron_layer_1_output_6*-1.59587) + (perceptron_layer_1_output_7*-2.15773) )
		
		perceptron_layer_3_output_0 = np.tanh( -0.411056 + (perceptron_layer_2_output_0*0.571671) + (perceptron_layer_2_output_1*0.0391907) + (perceptron_layer_2_output_2*-0.107998) + (perceptron_layer_2_output_3*1.10802) + (perceptron_layer_2_output_4*-0.444291) + (perceptron_layer_2_output_5*-0.512295) + (perceptron_layer_2_output_6*0.267053) + (perceptron_layer_2_output_7*0.535265) )
		perceptron_layer_3_output_1 = np.tanh( 0.625904 + (perceptron_layer_2_output_0*-2.37718) + (perceptron_layer_2_output_1*1.41907) + (perceptron_layer_2_output_2*1.30785) + (perceptron_layer_2_output_3*-1.03897) + (perceptron_layer_2_output_4*0.629018) + (perceptron_layer_2_output_5*0.738046) + (perceptron_layer_2_output_6*-2.6746) + (perceptron_layer_2_output_7*-0.654159) )
		perceptron_layer_3_output_2 = np.tanh( 0.1019 + (perceptron_layer_2_output_0*-0.132016) + (perceptron_layer_2_output_1*0.0832116) + (perceptron_layer_2_output_2*-0.381645) + (perceptron_layer_2_output_3*-0.562557) + (perceptron_layer_2_output_4*-0.0842534) + (perceptron_layer_2_output_5*-0.18706) + (perceptron_layer_2_output_6*-0.101161) + (perceptron_layer_2_output_7*-0.0240882) )
		perceptron_layer_3_output_3 = np.tanh( 1.01273 + (perceptron_layer_2_output_0*0.759365) + (perceptron_layer_2_output_1*0.369747) + (perceptron_layer_2_output_2*0.472156) + (perceptron_layer_2_output_3*0.0128442) + (perceptron_layer_2_output_4*0.472018) + (perceptron_layer_2_output_5*-0.878317) + (perceptron_layer_2_output_6*0.472471) + (perceptron_layer_2_output_7*0.0970386) )
		perceptron_layer_3_output_4 = np.tanh( -0.426179 + (perceptron_layer_2_output_0*-2.60295) + (perceptron_layer_2_output_1*-1.39123) + (perceptron_layer_2_output_2*1.3864) + (perceptron_layer_2_output_3*-1.40328) + (perceptron_layer_2_output_4*0.92914) + (perceptron_layer_2_output_5*0.842347) + (perceptron_layer_2_output_6*0.588607) + (perceptron_layer_2_output_7*1.21752) )
		perceptron_layer_3_output_5 = np.tanh( 0.00569165 + (perceptron_layer_2_output_0*0.228899) + (perceptron_layer_2_output_1*0.131018) + (perceptron_layer_2_output_2*-0.264785) + (perceptron_layer_2_output_3*-0.673391) + (perceptron_layer_2_output_4*-0.465137) + (perceptron_layer_2_output_5*2.56319) + (perceptron_layer_2_output_6*-1.13807) + (perceptron_layer_2_output_7*-1.02078) )
		perceptron_layer_3_output_6 = np.tanh( 0.261826 + (perceptron_layer_2_output_0*0.317662) + (perceptron_layer_2_output_1*0.254152) + (perceptron_layer_2_output_2*-1.1785) + (perceptron_layer_2_output_3*0.521571) + (perceptron_layer_2_output_4*-0.676011) + (perceptron_layer_2_output_5*0.0571536) + (perceptron_layer_2_output_6*-0.125756) + (perceptron_layer_2_output_7*-0.376908) )
		perceptron_layer_3_output_7 = np.tanh( 0.517901 + (perceptron_layer_2_output_0*0.477246) + (perceptron_layer_2_output_1*-0.077075) + (perceptron_layer_2_output_2*-0.102521) + (perceptron_layer_2_output_3*2.11554) + (perceptron_layer_2_output_4*-0.0296917) + (perceptron_layer_2_output_5*0.176016) + (perceptron_layer_2_output_6*-0.970643) + (perceptron_layer_2_output_7*-0.842264) )
		
		perceptron_layer_4_output_0 = ( -0.0176143 + (perceptron_layer_3_output_0*0.305002) + (perceptron_layer_3_output_1*-1.1507) + (perceptron_layer_3_output_2*0.614793) + (perceptron_layer_3_output_3*-0.540085) + (perceptron_layer_3_output_4*-1.02702) + (perceptron_layer_3_output_5*1.21269) + (perceptron_layer_3_output_6*-0.918054) + (perceptron_layer_3_output_7*0.662585) )
		
		unscaling_layer_output_0=perceptron_layer_4_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
