import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -0.416832 + (scaled_cement*-2.30391) + (scaled_fine_aggregate*0.0401533) + (scaled_coarse_aggregate*0.456027) + (scaled_wc*-2.48446) )
		perceptron_layer_1_output_1 = np.tanh( -0.705378 + (scaled_cement*-4.10061) + (scaled_fine_aggregate*-0.210523) + (scaled_coarse_aggregate*1.37851) + (scaled_wc*1.76103) )
		perceptron_layer_1_output_2 = np.tanh( -2.19092 + (scaled_cement*0.485138) + (scaled_fine_aggregate*1.10526) + (scaled_coarse_aggregate*-0.180441) + (scaled_wc*-3.11955) )
		perceptron_layer_1_output_3 = np.tanh( -1.07259 + (scaled_cement*1.22436) + (scaled_fine_aggregate*-0.390022) + (scaled_coarse_aggregate*0.800566) + (scaled_wc*-3.43864) )
		perceptron_layer_1_output_4 = np.tanh( 0.363508 + (scaled_cement*-0.649509) + (scaled_fine_aggregate*0.172494) + (scaled_coarse_aggregate*-0.797496) + (scaled_wc*3.14009) )
		perceptron_layer_1_output_5 = np.tanh( 1.38392 + (scaled_cement*-1.83481) + (scaled_fine_aggregate*1.27572) + (scaled_coarse_aggregate*0.88717) + (scaled_wc*0.139872) )
		perceptron_layer_1_output_6 = np.tanh( 0.536182 + (scaled_cement*0.863903) + (scaled_fine_aggregate*-0.0288997) + (scaled_coarse_aggregate*-0.0238629) + (scaled_wc*1.36046) )
		perceptron_layer_1_output_7 = np.tanh( -0.499634 + (scaled_cement*-3.22246) + (scaled_fine_aggregate*-1.17874) + (scaled_coarse_aggregate*-1.15564) + (scaled_wc*-0.618126) )
		
		perceptron_layer_2_output_0 = np.tanh( -0.0937716 + (perceptron_layer_1_output_0*-1.55988) + (perceptron_layer_1_output_1*-3.06037) + (perceptron_layer_1_output_2*-2.91149) + (perceptron_layer_1_output_3*1.87375) + (perceptron_layer_1_output_4*0.899666) + (perceptron_layer_1_output_5*2.37356) + (perceptron_layer_1_output_6*-0.0119474) + (perceptron_layer_1_output_7*-0.241013) )
		perceptron_layer_2_output_1 = np.tanh( -0.491247 + (perceptron_layer_1_output_0*0.162168) + (perceptron_layer_1_output_1*0.554074) + (perceptron_layer_1_output_2*-0.591076) + (perceptron_layer_1_output_3*-0.498096) + (perceptron_layer_1_output_4*0.871187) + (perceptron_layer_1_output_5*1.2352) + (perceptron_layer_1_output_6*0.359374) + (perceptron_layer_1_output_7*-1.13842) )
		perceptron_layer_2_output_2 = np.tanh( -0.525145 + (perceptron_layer_1_output_0*-1.13211) + (perceptron_layer_1_output_1*0.264667) + (perceptron_layer_1_output_2*0.0768937) + (perceptron_layer_1_output_3*-0.381598) + (perceptron_layer_1_output_4*-1.00027) + (perceptron_layer_1_output_5*-0.232601) + (perceptron_layer_1_output_6*-0.38477) + (perceptron_layer_1_output_7*-1.26978) )
		perceptron_layer_2_output_3 = np.tanh( -0.669078 + (perceptron_layer_1_output_0*-2.41435) + (perceptron_layer_1_output_1*-0.325177) + (perceptron_layer_1_output_2*-0.919526) + (perceptron_layer_1_output_3*-1.76363) + (perceptron_layer_1_output_4*0.0810711) + (perceptron_layer_1_output_5*0.474075) + (perceptron_layer_1_output_6*1.08753) + (perceptron_layer_1_output_7*-1.57175) )
		perceptron_layer_2_output_4 = np.tanh( -1.09758 + (perceptron_layer_1_output_0*-0.500723) + (perceptron_layer_1_output_1*0.223647) + (perceptron_layer_1_output_2*0.00295947) + (perceptron_layer_1_output_3*0.396358) + (perceptron_layer_1_output_4*-1.02931) + (perceptron_layer_1_output_5*0.341826) + (perceptron_layer_1_output_6*1.58432) + (perceptron_layer_1_output_7*-1.46304) )
		perceptron_layer_2_output_5 = np.tanh( 0.76479 + (perceptron_layer_1_output_0*-0.767428) + (perceptron_layer_1_output_1*0.254405) + (perceptron_layer_1_output_2*0.563754) + (perceptron_layer_1_output_3*-0.25362) + (perceptron_layer_1_output_4*0.947361) + (perceptron_layer_1_output_5*-0.491708) + (perceptron_layer_1_output_6*1.60385) + (perceptron_layer_1_output_7*-1.79226) )
		perceptron_layer_2_output_6 = np.tanh( 0.300788 + (perceptron_layer_1_output_0*1.08213) + (perceptron_layer_1_output_1*0.0213252) + (perceptron_layer_1_output_2*0.44282) + (perceptron_layer_1_output_3*0.370296) + (perceptron_layer_1_output_4*0.0132624) + (perceptron_layer_1_output_5*-0.184059) + (perceptron_layer_1_output_6*-0.963042) + (perceptron_layer_1_output_7*0.675082) )
		perceptron_layer_2_output_7 = np.tanh( -0.0290462 + (perceptron_layer_1_output_0*0.900383) + (perceptron_layer_1_output_1*-0.230575) + (perceptron_layer_1_output_2*0.517399) + (perceptron_layer_1_output_3*0.659629) + (perceptron_layer_1_output_4*0.398647) + (perceptron_layer_1_output_5*-1.91688) + (perceptron_layer_1_output_6*-1.63906) + (perceptron_layer_1_output_7*1.40245) )
		
		perceptron_layer_3_output_0 = np.tanh( -1.50959 + (perceptron_layer_2_output_0*0.0509531) + (perceptron_layer_2_output_1*-0.33735) + (perceptron_layer_2_output_2*-0.835682) + (perceptron_layer_2_output_3*0.13616) + (perceptron_layer_2_output_4*0.96063) + (perceptron_layer_2_output_5*0.973008) + (perceptron_layer_2_output_6*-0.543779) + (perceptron_layer_2_output_7*0.230253) )
		perceptron_layer_3_output_1 = np.tanh( 0.516415 + (perceptron_layer_2_output_0*2.48168) + (perceptron_layer_2_output_1*0.765506) + (perceptron_layer_2_output_2*-0.360815) + (perceptron_layer_2_output_3*-0.042664) + (perceptron_layer_2_output_4*-0.275473) + (perceptron_layer_2_output_5*0.874982) + (perceptron_layer_2_output_6*-0.572811) + (perceptron_layer_2_output_7*-0.556262) )
		perceptron_layer_3_output_2 = np.tanh( 0.0648948 + (perceptron_layer_2_output_0*0.115321) + (perceptron_layer_2_output_1*0.160969) + (perceptron_layer_2_output_2*-0.00246684) + (perceptron_layer_2_output_3*0.119079) + (perceptron_layer_2_output_4*-0.0137228) + (perceptron_layer_2_output_5*0.262251) + (perceptron_layer_2_output_6*-0.113504) + (perceptron_layer_2_output_7*-0.295561) )
		perceptron_layer_3_output_3 = np.tanh( -0.123014 + (perceptron_layer_2_output_0*-0.71285) + (perceptron_layer_2_output_1*-0.911894) + (perceptron_layer_2_output_2*0.751083) + (perceptron_layer_2_output_3*0.384445) + (perceptron_layer_2_output_4*-0.332769) + (perceptron_layer_2_output_5*-0.886165) + (perceptron_layer_2_output_6*0.206656) + (perceptron_layer_2_output_7*0.744493) )
		perceptron_layer_3_output_4 = np.tanh( 0.331165 + (perceptron_layer_2_output_0*-1.22921) + (perceptron_layer_2_output_1*0.371848) + (perceptron_layer_2_output_2*0.794851) + (perceptron_layer_2_output_3*1.07796) + (perceptron_layer_2_output_4*-0.329914) + (perceptron_layer_2_output_5*-0.430951) + (perceptron_layer_2_output_6*-0.557672) + (perceptron_layer_2_output_7*0.315021) )
		perceptron_layer_3_output_5 = np.tanh( 1.20442 + (perceptron_layer_2_output_0*0.913291) + (perceptron_layer_2_output_1*-0.443106) + (perceptron_layer_2_output_2*-0.31598) + (perceptron_layer_2_output_3*1.0851) + (perceptron_layer_2_output_4*1.32516) + (perceptron_layer_2_output_5*-0.469648) + (perceptron_layer_2_output_6*0.698265) + (perceptron_layer_2_output_7*-1.27665) )
		perceptron_layer_3_output_6 = np.tanh( -0.0169864 + (perceptron_layer_2_output_0*0.0253198) + (perceptron_layer_2_output_1*-0.144769) + (perceptron_layer_2_output_2*-0.0546606) + (perceptron_layer_2_output_3*0.0896827) + (perceptron_layer_2_output_4*0.0125972) + (perceptron_layer_2_output_5*-0.14317) + (perceptron_layer_2_output_6*0.145447) + (perceptron_layer_2_output_7*0.101034) )
		perceptron_layer_3_output_7 = np.tanh( 0.360646 + (perceptron_layer_2_output_0*0.733178) + (perceptron_layer_2_output_1*1.53116) + (perceptron_layer_2_output_2*-0.354441) + (perceptron_layer_2_output_3*-0.977016) + (perceptron_layer_2_output_4*0.132464) + (perceptron_layer_2_output_5*0.117174) + (perceptron_layer_2_output_6*0.186125) + (perceptron_layer_2_output_7*0.776778) )
		
		perceptron_layer_4_output_0 = ( -0.502929 + (perceptron_layer_3_output_0*-1.60502) + (perceptron_layer_3_output_1*-1.45556) + (perceptron_layer_3_output_2*-0.0832575) + (perceptron_layer_3_output_3*0.747577) + (perceptron_layer_3_output_4*0.685929) + (perceptron_layer_3_output_5*2.16548) + (perceptron_layer_3_output_6*-0.0367995) + (perceptron_layer_3_output_7*-0.923923) )
		
		unscaling_layer_output_0=perceptron_layer_4_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
