import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -0.439514 + (scaled_cement*-1.90851) + (scaled_fine_aggregate*-0.187745) + (scaled_coarse_aggregate*0.783887) + (scaled_wc*1.55197) )
		perceptron_layer_1_output_1 = np.tanh( -0.689186 + (scaled_cement*0.616195) + (scaled_fine_aggregate*-2.76861) + (scaled_coarse_aggregate*-2.00166) + (scaled_wc*-1.36389) )
		perceptron_layer_1_output_2 = np.tanh( 1.06754 + (scaled_cement*-1.31527) + (scaled_fine_aggregate*-0.00357874) + (scaled_coarse_aggregate*-0.509729) + (scaled_wc*1.96952) )
		perceptron_layer_1_output_3 = np.tanh( 0.420956 + (scaled_cement*-0.0793409) + (scaled_fine_aggregate*-1.05274) + (scaled_coarse_aggregate*-0.304836) + (scaled_wc*0.401641) )
		perceptron_layer_1_output_4 = np.tanh( 0.153729 + (scaled_cement*1.26196) + (scaled_fine_aggregate*-0.258083) + (scaled_coarse_aggregate*-0.250784) + (scaled_wc*1.84813) )
		perceptron_layer_1_output_5 = np.tanh( 0.424751 + (scaled_cement*-1.14101) + (scaled_fine_aggregate*1.95305) + (scaled_coarse_aggregate*0.121357) + (scaled_wc*0.711231) )
		perceptron_layer_1_output_6 = np.tanh( 1.93785 + (scaled_cement*0.513112) + (scaled_fine_aggregate*-0.22164) + (scaled_coarse_aggregate*0.154021) + (scaled_wc*2.68821) )
		perceptron_layer_1_output_7 = np.tanh( -0.829911 + (scaled_cement*-2.45127) + (scaled_fine_aggregate*-0.152834) + (scaled_coarse_aggregate*-1.50623) + (scaled_wc*0.305975) )
		
		perceptron_layer_2_output_0 = np.tanh( -0.170874 + (perceptron_layer_1_output_0*0.33151) + (perceptron_layer_1_output_1*-0.529418) + (perceptron_layer_1_output_2*-0.296954) + (perceptron_layer_1_output_3*1.29775) + (perceptron_layer_1_output_4*-0.954087) + (perceptron_layer_1_output_5*0.00266014) + (perceptron_layer_1_output_6*-1.60541) + (perceptron_layer_1_output_7*-0.462066) )
		perceptron_layer_2_output_1 = np.tanh( 0.35625 + (perceptron_layer_1_output_0*-2.51744) + (perceptron_layer_1_output_1*-0.0908832) + (perceptron_layer_1_output_2*-0.360063) + (perceptron_layer_1_output_3*-0.105369) + (perceptron_layer_1_output_4*1.6782) + (perceptron_layer_1_output_5*-0.572204) + (perceptron_layer_1_output_6*2.24955) + (perceptron_layer_1_output_7*0.176431) )
		perceptron_layer_2_output_2 = np.tanh( 0.426683 + (perceptron_layer_1_output_0*0.427212) + (perceptron_layer_1_output_1*0.531902) + (perceptron_layer_1_output_2*0.0151184) + (perceptron_layer_1_output_3*-0.0679557) + (perceptron_layer_1_output_4*0.676634) + (perceptron_layer_1_output_5*0.784612) + (perceptron_layer_1_output_6*1.20653) + (perceptron_layer_1_output_7*-2.11506) )
		perceptron_layer_2_output_3 = np.tanh( 1.4195 + (perceptron_layer_1_output_0*0.771731) + (perceptron_layer_1_output_1*0.749145) + (perceptron_layer_1_output_2*2.16116) + (perceptron_layer_1_output_3*1.162) + (perceptron_layer_1_output_4*-1.6382) + (perceptron_layer_1_output_5*-1.64823) + (perceptron_layer_1_output_6*-1.86973) + (perceptron_layer_1_output_7*1.55714) )
		perceptron_layer_2_output_4 = np.tanh( 0.00896173 + (perceptron_layer_1_output_0*0.455553) + (perceptron_layer_1_output_1*0.480531) + (perceptron_layer_1_output_2*0.963477) + (perceptron_layer_1_output_3*-1.04378) + (perceptron_layer_1_output_4*1.33241) + (perceptron_layer_1_output_5*-1.04007) + (perceptron_layer_1_output_6*-2.02212) + (perceptron_layer_1_output_7*-0.662202) )
		perceptron_layer_2_output_5 = np.tanh( 0.437448 + (perceptron_layer_1_output_0*2.05977) + (perceptron_layer_1_output_1*-0.0373089) + (perceptron_layer_1_output_2*-0.00458555) + (perceptron_layer_1_output_3*-0.535556) + (perceptron_layer_1_output_4*-0.137455) + (perceptron_layer_1_output_5*0.31247) + (perceptron_layer_1_output_6*-0.701141) + (perceptron_layer_1_output_7*-0.438056) )
		perceptron_layer_2_output_6 = np.tanh( 1.20335 + (perceptron_layer_1_output_0*-0.289423) + (perceptron_layer_1_output_1*1.61801) + (perceptron_layer_1_output_2*-0.515657) + (perceptron_layer_1_output_3*-0.811314) + (perceptron_layer_1_output_4*-1.90159) + (perceptron_layer_1_output_5*0.882227) + (perceptron_layer_1_output_6*-0.124316) + (perceptron_layer_1_output_7*-1.09489) )
		perceptron_layer_2_output_7 = np.tanh( -1.29224 + (perceptron_layer_1_output_0*1.41176) + (perceptron_layer_1_output_1*-0.152844) + (perceptron_layer_1_output_2*-0.110728) + (perceptron_layer_1_output_3*-0.910591) + (perceptron_layer_1_output_4*-0.982627) + (perceptron_layer_1_output_5*-0.251922) + (perceptron_layer_1_output_6*-1.44574) + (perceptron_layer_1_output_7*0.497569) )
		
		perceptron_layer_3_output_0 = np.tanh( 0.70278 + (perceptron_layer_2_output_0*1.80049) + (perceptron_layer_2_output_1*1.03181) + (perceptron_layer_2_output_2*-1.17752) + (perceptron_layer_2_output_3*-0.629637) + (perceptron_layer_2_output_4*-0.907884) + (perceptron_layer_2_output_5*0.632771) + (perceptron_layer_2_output_6*-2.09967) + (perceptron_layer_2_output_7*-1.82342) )
		perceptron_layer_3_output_1 = np.tanh( -0.145923 + (perceptron_layer_2_output_0*-0.33993) + (perceptron_layer_2_output_1*2.31635) + (perceptron_layer_2_output_2*-0.776903) + (perceptron_layer_2_output_3*-1.57016) + (perceptron_layer_2_output_4*-2.28754) + (perceptron_layer_2_output_5*-2.24353) + (perceptron_layer_2_output_6*-0.969876) + (perceptron_layer_2_output_7*-1.23446) )
		perceptron_layer_3_output_2 = np.tanh( 0.733548 + (perceptron_layer_2_output_0*0.284052) + (perceptron_layer_2_output_1*0.791401) + (perceptron_layer_2_output_2*0.0432781) + (perceptron_layer_2_output_3*0.754774) + (perceptron_layer_2_output_4*0.141416) + (perceptron_layer_2_output_5*-0.245893) + (perceptron_layer_2_output_6*0.930082) + (perceptron_layer_2_output_7*-0.87457) )
		perceptron_layer_3_output_3 = np.tanh( -0.347917 + (perceptron_layer_2_output_0*0.813937) + (perceptron_layer_2_output_1*0.0573023) + (perceptron_layer_2_output_2*-0.0723353) + (perceptron_layer_2_output_3*0.0879336) + (perceptron_layer_2_output_4*0.0534794) + (perceptron_layer_2_output_5*0.0985798) + (perceptron_layer_2_output_6*-0.469125) + (perceptron_layer_2_output_7*-0.178964) )
		perceptron_layer_3_output_4 = np.tanh( -0.449654 + (perceptron_layer_2_output_0*0.208346) + (perceptron_layer_2_output_1*0.380053) + (perceptron_layer_2_output_2*0.222878) + (perceptron_layer_2_output_3*-0.808584) + (perceptron_layer_2_output_4*-1.03023) + (perceptron_layer_2_output_5*-0.290219) + (perceptron_layer_2_output_6*-0.736493) + (perceptron_layer_2_output_7*0.429717) )
		perceptron_layer_3_output_5 = np.tanh( -0.55112 + (perceptron_layer_2_output_0*-0.399271) + (perceptron_layer_2_output_1*1.07981) + (perceptron_layer_2_output_2*1.38742) + (perceptron_layer_2_output_3*-2.84999) + (perceptron_layer_2_output_4*0.0683641) + (perceptron_layer_2_output_5*0.440197) + (perceptron_layer_2_output_6*0.238718) + (perceptron_layer_2_output_7*-0.0348486) )
		perceptron_layer_3_output_6 = np.tanh( -0.992409 + (perceptron_layer_2_output_0*-0.250974) + (perceptron_layer_2_output_1*1.18557) + (perceptron_layer_2_output_2*-0.4623) + (perceptron_layer_2_output_3*-0.748039) + (perceptron_layer_2_output_4*-1.84471) + (perceptron_layer_2_output_5*-0.97753) + (perceptron_layer_2_output_6*-0.255989) + (perceptron_layer_2_output_7*-0.342715) )
		perceptron_layer_3_output_7 = np.tanh( 0.380705 + (perceptron_layer_2_output_0*-0.478712) + (perceptron_layer_2_output_1*-0.545055) + (perceptron_layer_2_output_2*-0.395756) + (perceptron_layer_2_output_3*0.898197) + (perceptron_layer_2_output_4*-0.0746184) + (perceptron_layer_2_output_5*-0.0432182) + (perceptron_layer_2_output_6*-1.94957) + (perceptron_layer_2_output_7*0.566558) )
		
		perceptron_layer_4_output_0 = np.tanh( 0.00341898 + (perceptron_layer_3_output_0*1.38626) + (perceptron_layer_3_output_1*0.263666) + (perceptron_layer_3_output_2*-0.037247) + (perceptron_layer_3_output_3*0.437372) + (perceptron_layer_3_output_4*1.23905) + (perceptron_layer_3_output_5*2.69554) + (perceptron_layer_3_output_6*0.489901) + (perceptron_layer_3_output_7*-1.4129) )
		perceptron_layer_4_output_1 = np.tanh( 0.0528648 + (perceptron_layer_3_output_0*-0.274574) + (perceptron_layer_3_output_1*1.19557) + (perceptron_layer_3_output_2*0.868578) + (perceptron_layer_3_output_3*0.393057) + (perceptron_layer_3_output_4*0.315639) + (perceptron_layer_3_output_5*-0.141969) + (perceptron_layer_3_output_6*-0.998086) + (perceptron_layer_3_output_7*0.385125) )
		perceptron_layer_4_output_2 = np.tanh( 0.0107812 + (perceptron_layer_3_output_0*-0.326951) + (perceptron_layer_3_output_1*0.249554) + (perceptron_layer_3_output_2*0.326991) + (perceptron_layer_3_output_3*0.596292) + (perceptron_layer_3_output_4*-0.304553) + (perceptron_layer_3_output_5*0.690766) + (perceptron_layer_3_output_6*0.674434) + (perceptron_layer_3_output_7*-1.02251) )
		perceptron_layer_4_output_3 = np.tanh( 0.103735 + (perceptron_layer_3_output_0*-0.587115) + (perceptron_layer_3_output_1*-0.260493) + (perceptron_layer_3_output_2*-0.0811228) + (perceptron_layer_3_output_3*0.0482345) + (perceptron_layer_3_output_4*-0.174289) + (perceptron_layer_3_output_5*-1.13539) + (perceptron_layer_3_output_6*-0.134029) + (perceptron_layer_3_output_7*0.301522) )
		perceptron_layer_4_output_4 = np.tanh( -0.0886639 + (perceptron_layer_3_output_0*-0.100736) + (perceptron_layer_3_output_1*0.356559) + (perceptron_layer_3_output_2*0.173428) + (perceptron_layer_3_output_3*0.089617) + (perceptron_layer_3_output_4*0.188604) + (perceptron_layer_3_output_5*-0.498193) + (perceptron_layer_3_output_6*-0.41049) + (perceptron_layer_3_output_7*0.333817) )
		perceptron_layer_4_output_5 = np.tanh( 1.47929 + (perceptron_layer_3_output_0*0.0508783) + (perceptron_layer_3_output_1*-1.57821) + (perceptron_layer_3_output_2*-1.04726) + (perceptron_layer_3_output_3*0.0263886) + (perceptron_layer_3_output_4*0.00098556) + (perceptron_layer_3_output_5*-1.78172) + (perceptron_layer_3_output_6*0.0404066) + (perceptron_layer_3_output_7*0.756851) )
		perceptron_layer_4_output_6 = np.tanh( 0.557806 + (perceptron_layer_3_output_0*-0.571034) + (perceptron_layer_3_output_1*-0.113908) + (perceptron_layer_3_output_2*-0.206377) + (perceptron_layer_3_output_3*-0.382378) + (perceptron_layer_3_output_4*-0.00782257) + (perceptron_layer_3_output_5*1.3891) + (perceptron_layer_3_output_6*0.814557) + (perceptron_layer_3_output_7*0.135749) )
		perceptron_layer_4_output_7 = np.tanh( -0.024606 + (perceptron_layer_3_output_0*-0.803229) + (perceptron_layer_3_output_1*-0.586649) + (perceptron_layer_3_output_2*0.412487) + (perceptron_layer_3_output_3*-0.771565) + (perceptron_layer_3_output_4*-0.356555) + (perceptron_layer_3_output_5*-2.28891) + (perceptron_layer_3_output_6*-0.358271) + (perceptron_layer_3_output_7*1.66443) )
		
		perceptron_layer_5_output_0 = ( -0.871034 + (perceptron_layer_4_output_0*1.50205) + (perceptron_layer_4_output_1*1.899) + (perceptron_layer_4_output_2*1.54901) + (perceptron_layer_4_output_3*2.59276) + (perceptron_layer_4_output_4*0.72661) + (perceptron_layer_4_output_5*2.73864) + (perceptron_layer_4_output_6*1.17465) + (perceptron_layer_4_output_7*-1.36426) )
		
		unscaling_layer_output_0=perceptron_layer_5_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
