import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -1.2278 + (scaled_cement*-0.305675) + (scaled_fine_aggregate*-0.853665) + (scaled_coarse_aggregate*-0.503988) + (scaled_wc*-2.01023) )
		perceptron_layer_1_output_1 = np.tanh( -0.552094 + (scaled_cement*-3.74566) + (scaled_fine_aggregate*-0.0350105) + (scaled_coarse_aggregate*-0.108197) + (scaled_wc*1.85403) )
		perceptron_layer_1_output_2 = np.tanh( 0.55806 + (scaled_cement*0.145784) + (scaled_fine_aggregate*-0.438754) + (scaled_coarse_aggregate*-0.0112886) + (scaled_wc*1.41489) )
		perceptron_layer_1_output_3 = np.tanh( 0.677243 + (scaled_cement*0.189762) + (scaled_fine_aggregate*-0.390567) + (scaled_coarse_aggregate*-0.703191) + (scaled_wc*-1.68396) )
		perceptron_layer_1_output_4 = np.tanh( -1.18868 + (scaled_cement*-3.32977) + (scaled_fine_aggregate*-0.312886) + (scaled_coarse_aggregate*0.117131) + (scaled_wc*-2.14561) )
		perceptron_layer_1_output_5 = np.tanh( 0.275096 + (scaled_cement*-0.693137) + (scaled_fine_aggregate*-0.0957641) + (scaled_coarse_aggregate*-0.614712) + (scaled_wc*3.26527) )
		perceptron_layer_1_output_6 = np.tanh( -0.730808 + (scaled_cement*0.962531) + (scaled_fine_aggregate*-0.124673) + (scaled_coarse_aggregate*1.31793) + (scaled_wc*0.585955) )
		perceptron_layer_1_output_7 = np.tanh( -0.738322 + (scaled_cement*1.69204) + (scaled_fine_aggregate*-1.47009) + (scaled_coarse_aggregate*-1.96093) + (scaled_wc*-0.970027) )
		
		perceptron_layer_2_output_0 = np.tanh( -0.825016 + (perceptron_layer_1_output_0*1.42463) + (perceptron_layer_1_output_1*1.22527) + (perceptron_layer_1_output_2*-0.0396083) + (perceptron_layer_1_output_3*-0.126952) + (perceptron_layer_1_output_4*0.309688) + (perceptron_layer_1_output_5*1.01086) + (perceptron_layer_1_output_6*-3.40629) + (perceptron_layer_1_output_7*0.237753) )
		perceptron_layer_2_output_1 = np.tanh( 0.668173 + (perceptron_layer_1_output_0*-1.07794) + (perceptron_layer_1_output_1*-0.378655) + (perceptron_layer_1_output_2*-1.74213) + (perceptron_layer_1_output_3*-1.09621) + (perceptron_layer_1_output_4*-1.43018) + (perceptron_layer_1_output_5*1.55323) + (perceptron_layer_1_output_6*2.02257) + (perceptron_layer_1_output_7*-1.16768) )
		perceptron_layer_2_output_2 = np.tanh( 0.569385 + (perceptron_layer_1_output_0*-0.63701) + (perceptron_layer_1_output_1*-0.232677) + (perceptron_layer_1_output_2*0.328051) + (perceptron_layer_1_output_3*-0.527009) + (perceptron_layer_1_output_4*-0.639178) + (perceptron_layer_1_output_5*-1.35077) + (perceptron_layer_1_output_6*-0.678651) + (perceptron_layer_1_output_7*0.141461) )
		perceptron_layer_2_output_3 = np.tanh( 0.300088 + (perceptron_layer_1_output_0*0.493403) + (perceptron_layer_1_output_1*-1.15965) + (perceptron_layer_1_output_2*-0.717238) + (perceptron_layer_1_output_3*-1.41561) + (perceptron_layer_1_output_4*-1.58026) + (perceptron_layer_1_output_5*-0.0570594) + (perceptron_layer_1_output_6*-0.282742) + (perceptron_layer_1_output_7*-0.732401) )
		perceptron_layer_2_output_4 = np.tanh( 0.0891324 + (perceptron_layer_1_output_0*-1.50598) + (perceptron_layer_1_output_1*-0.190611) + (perceptron_layer_1_output_2*1.98308) + (perceptron_layer_1_output_3*0.362098) + (perceptron_layer_1_output_4*-1.20798) + (perceptron_layer_1_output_5*0.102808) + (perceptron_layer_1_output_6*-0.314613) + (perceptron_layer_1_output_7*-0.607882) )
		perceptron_layer_2_output_5 = np.tanh( -1.60211 + (perceptron_layer_1_output_0*-1.7246) + (perceptron_layer_1_output_1*-1.6567) + (perceptron_layer_1_output_2*1.25336) + (perceptron_layer_1_output_3*-0.871334) + (perceptron_layer_1_output_4*1.9522) + (perceptron_layer_1_output_5*-0.245885) + (perceptron_layer_1_output_6*-0.180146) + (perceptron_layer_1_output_7*1.94228) )
		perceptron_layer_2_output_6 = np.tanh( 3.00846 + (perceptron_layer_1_output_0*-0.00841871) + (perceptron_layer_1_output_1*0.334109) + (perceptron_layer_1_output_2*1.00498) + (perceptron_layer_1_output_3*-0.180463) + (perceptron_layer_1_output_4*0.862209) + (perceptron_layer_1_output_5*1.65209) + (perceptron_layer_1_output_6*1.58789) + (perceptron_layer_1_output_7*0.0578521) )
		perceptron_layer_2_output_7 = np.tanh( 0.298953 + (perceptron_layer_1_output_0*0.642612) + (perceptron_layer_1_output_1*3.60014) + (perceptron_layer_1_output_2*0.602459) + (perceptron_layer_1_output_3*-0.149384) + (perceptron_layer_1_output_4*0.322552) + (perceptron_layer_1_output_5*-1.12398) + (perceptron_layer_1_output_6*-0.926888) + (perceptron_layer_1_output_7*1.32214) )
		
		perceptron_layer_3_output_0 = np.tanh( 0.75504 + (perceptron_layer_2_output_0*1.84125) + (perceptron_layer_2_output_1*-0.250911) + (perceptron_layer_2_output_2*-0.0368593) + (perceptron_layer_2_output_3*-0.85536) + (perceptron_layer_2_output_4*-1.95104) + (perceptron_layer_2_output_5*0.454483) + (perceptron_layer_2_output_6*-0.196637) + (perceptron_layer_2_output_7*-0.375554) )
		perceptron_layer_3_output_1 = np.tanh( -1.13232 + (perceptron_layer_2_output_0*2.72291) + (perceptron_layer_2_output_1*0.609676) + (perceptron_layer_2_output_2*0.114881) + (perceptron_layer_2_output_3*0.380113) + (perceptron_layer_2_output_4*-1.57061) + (perceptron_layer_2_output_5*2.8231) + (perceptron_layer_2_output_6*0.0913606) + (perceptron_layer_2_output_7*2.05808) )
		perceptron_layer_3_output_2 = np.tanh( -0.944778 + (perceptron_layer_2_output_0*-0.0125314) + (perceptron_layer_2_output_1*3.08023) + (perceptron_layer_2_output_2*1.43753) + (perceptron_layer_2_output_3*-1.39331) + (perceptron_layer_2_output_4*-1.25313) + (perceptron_layer_2_output_5*-0.600172) + (perceptron_layer_2_output_6*-2.48243) + (perceptron_layer_2_output_7*1.01411) )
		perceptron_layer_3_output_3 = np.tanh( -0.0400363 + (perceptron_layer_2_output_0*0.751647) + (perceptron_layer_2_output_1*-0.767161) + (perceptron_layer_2_output_2*-0.147163) + (perceptron_layer_2_output_3*-0.0251544) + (perceptron_layer_2_output_4*0.109748) + (perceptron_layer_2_output_5*0.398299) + (perceptron_layer_2_output_6*0.0771544) + (perceptron_layer_2_output_7*-0.506121) )
		perceptron_layer_3_output_4 = np.tanh( -0.853021 + (perceptron_layer_2_output_0*0.60071) + (perceptron_layer_2_output_1*0.254008) + (perceptron_layer_2_output_2*0.361967) + (perceptron_layer_2_output_3*0.0570516) + (perceptron_layer_2_output_4*0.996109) + (perceptron_layer_2_output_5*-0.68512) + (perceptron_layer_2_output_6*-0.633189) + (perceptron_layer_2_output_7*-1.03983) )
		perceptron_layer_3_output_5 = np.tanh( -1.26114 + (perceptron_layer_2_output_0*0.659564) + (perceptron_layer_2_output_1*0.584224) + (perceptron_layer_2_output_2*1.31589) + (perceptron_layer_2_output_3*0.628274) + (perceptron_layer_2_output_4*1.29642) + (perceptron_layer_2_output_5*1.56786) + (perceptron_layer_2_output_6*0.976961) + (perceptron_layer_2_output_7*-1.69056) )
		perceptron_layer_3_output_6 = np.tanh( 0.439847 + (perceptron_layer_2_output_0*-0.526119) + (perceptron_layer_2_output_1*-0.160038) + (perceptron_layer_2_output_2*0.135385) + (perceptron_layer_2_output_3*0.235502) + (perceptron_layer_2_output_4*-0.0462254) + (perceptron_layer_2_output_5*-0.18571) + (perceptron_layer_2_output_6*-0.337607) + (perceptron_layer_2_output_7*-0.296759) )
		perceptron_layer_3_output_7 = np.tanh( -0.767939 + (perceptron_layer_2_output_0*0.203155) + (perceptron_layer_2_output_1*-0.87962) + (perceptron_layer_2_output_2*-0.233923) + (perceptron_layer_2_output_3*0.116125) + (perceptron_layer_2_output_4*0.678033) + (perceptron_layer_2_output_5*-0.165307) + (perceptron_layer_2_output_6*-1.26493) + (perceptron_layer_2_output_7*1.89123) )
		
		perceptron_layer_4_output_0 = np.tanh( -0.029589 + (perceptron_layer_3_output_0*-0.515155) + (perceptron_layer_3_output_1*-1.3549) + (perceptron_layer_3_output_2*-0.290136) + (perceptron_layer_3_output_3*0.218763) + (perceptron_layer_3_output_4*0.357813) + (perceptron_layer_3_output_5*-0.214645) + (perceptron_layer_3_output_6*0.576871) + (perceptron_layer_3_output_7*-1.1506) )
		perceptron_layer_4_output_1 = np.tanh( 0.239634 + (perceptron_layer_3_output_0*0.00315998) + (perceptron_layer_3_output_1*-0.0990807) + (perceptron_layer_3_output_2*-0.0245861) + (perceptron_layer_3_output_3*-0.158868) + (perceptron_layer_3_output_4*0.727464) + (perceptron_layer_3_output_5*-0.412199) + (perceptron_layer_3_output_6*-1.02061) + (perceptron_layer_3_output_7*-1.42732) )
		perceptron_layer_4_output_2 = np.tanh( 0.287099 + (perceptron_layer_3_output_0*-0.199264) + (perceptron_layer_3_output_1*-0.385945) + (perceptron_layer_3_output_2*-0.234167) + (perceptron_layer_3_output_3*0.405096) + (perceptron_layer_3_output_4*-0.553198) + (perceptron_layer_3_output_5*0.514009) + (perceptron_layer_3_output_6*0.63609) + (perceptron_layer_3_output_7*-0.0403076) )
		perceptron_layer_4_output_3 = np.tanh( 0.179125 + (perceptron_layer_3_output_0*-0.0990747) + (perceptron_layer_3_output_1*-0.305403) + (perceptron_layer_3_output_2*-0.479382) + (perceptron_layer_3_output_3*0.462606) + (perceptron_layer_3_output_4*-0.38881) + (perceptron_layer_3_output_5*0.20592) + (perceptron_layer_3_output_6*0.472271) + (perceptron_layer_3_output_7*0.190546) )
		perceptron_layer_4_output_4 = np.tanh( -0.0864931 + (perceptron_layer_3_output_0*-1.00981) + (perceptron_layer_3_output_1*-0.751114) + (perceptron_layer_3_output_2*1.17935) + (perceptron_layer_3_output_3*1.40314) + (perceptron_layer_3_output_4*-0.430962) + (perceptron_layer_3_output_5*0.896086) + (perceptron_layer_3_output_6*1.13099) + (perceptron_layer_3_output_7*-0.513741) )
		perceptron_layer_4_output_5 = np.tanh( 0.519621 + (perceptron_layer_3_output_0*-0.724031) + (perceptron_layer_3_output_1*-2.41439) + (perceptron_layer_3_output_2*0.676017) + (perceptron_layer_3_output_3*-0.661649) + (perceptron_layer_3_output_4*-0.89126) + (perceptron_layer_3_output_5*0.665563) + (perceptron_layer_3_output_6*0.567764) + (perceptron_layer_3_output_7*-0.555287) )
		perceptron_layer_4_output_6 = np.tanh( -0.492363 + (perceptron_layer_3_output_0*-1.48757) + (perceptron_layer_3_output_1*-0.599165) + (perceptron_layer_3_output_2*0.0128035) + (perceptron_layer_3_output_3*-0.278783) + (perceptron_layer_3_output_4*1.45404) + (perceptron_layer_3_output_5*0.0693636) + (perceptron_layer_3_output_6*-0.32867) + (perceptron_layer_3_output_7*-0.232151) )
		perceptron_layer_4_output_7 = np.tanh( -0.398224 + (perceptron_layer_3_output_0*0.17429) + (perceptron_layer_3_output_1*0.737588) + (perceptron_layer_3_output_2*0.0232402) + (perceptron_layer_3_output_3*0.0328559) + (perceptron_layer_3_output_4*0.676952) + (perceptron_layer_3_output_5*-0.240507) + (perceptron_layer_3_output_6*-0.858287) + (perceptron_layer_3_output_7*-0.0409826) )
		
		perceptron_layer_5_output_0 = ( 0.577391 + (perceptron_layer_4_output_0*-1.02512) + (perceptron_layer_4_output_1*-1.36448) + (perceptron_layer_4_output_2*-0.574353) + (perceptron_layer_4_output_3*-0.590009) + (perceptron_layer_4_output_4*1.85941) + (perceptron_layer_4_output_5*2.04553) + (perceptron_layer_4_output_6*-1.7307) + (perceptron_layer_4_output_7*0.0518152) )
		
		unscaling_layer_output_0=perceptron_layer_5_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
