import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -0.620845 + (scaled_cement*-0.957026) + (scaled_fine_aggregate*0.0863817) + (scaled_coarse_aggregate*0.428217) + (scaled_wc*-1.5553) )
		perceptron_layer_1_output_1 = np.tanh( -2.0707 + (scaled_cement*2.83396) + (scaled_fine_aggregate*-1.08402) + (scaled_coarse_aggregate*-0.982345) + (scaled_wc*-2.81593) )
		perceptron_layer_1_output_2 = np.tanh( 0.190103 + (scaled_cement*-1.42302) + (scaled_fine_aggregate*0.299548) + (scaled_coarse_aggregate*0.0923464) + (scaled_wc*1.52612) )
		perceptron_layer_1_output_3 = np.tanh( -0.246428 + (scaled_cement*0.618785) + (scaled_fine_aggregate*-0.774357) + (scaled_coarse_aggregate*0.107283) + (scaled_wc*-0.187086) )
		perceptron_layer_1_output_4 = np.tanh( -0.501653 + (scaled_cement*0.0831333) + (scaled_fine_aggregate*0.1552) + (scaled_coarse_aggregate*-0.170596) + (scaled_wc*-0.290537) )
		perceptron_layer_1_output_5 = np.tanh( -0.378002 + (scaled_cement*-0.150756) + (scaled_fine_aggregate*-0.302911) + (scaled_coarse_aggregate*-0.650072) + (scaled_wc*0.559681) )
		perceptron_layer_1_output_6 = np.tanh( -0.356932 + (scaled_cement*0.198208) + (scaled_fine_aggregate*-0.38059) + (scaled_coarse_aggregate*0.987813) + (scaled_wc*-0.440962) )
		perceptron_layer_1_output_7 = np.tanh( -0.187792 + (scaled_cement*-1.97801) + (scaled_fine_aggregate*-1.11427) + (scaled_coarse_aggregate*-1.33735) + (scaled_wc*-0.25046) )
		
		perceptron_layer_2_output_0 = np.tanh( 0.763651 + (perceptron_layer_1_output_0*1.48244) + (perceptron_layer_1_output_1*-0.255278) + (perceptron_layer_1_output_2*1.15378) + (perceptron_layer_1_output_3*2.18309) + (perceptron_layer_1_output_4*0.84058) + (perceptron_layer_1_output_5*-3.22049) + (perceptron_layer_1_output_6*-1.12083) + (perceptron_layer_1_output_7*3.91844) )
		perceptron_layer_2_output_1 = np.tanh( 0.365049 + (perceptron_layer_1_output_0*0.621479) + (perceptron_layer_1_output_1*-0.0300514) + (perceptron_layer_1_output_2*0.356046) + (perceptron_layer_1_output_3*0.841821) + (perceptron_layer_1_output_4*1.16803) + (perceptron_layer_1_output_5*-0.650615) + (perceptron_layer_1_output_6*0.831107) + (perceptron_layer_1_output_7*1.82226) )
		perceptron_layer_2_output_2 = np.tanh( 0.164076 + (perceptron_layer_1_output_0*-0.00486507) + (perceptron_layer_1_output_1*0.327071) + (perceptron_layer_1_output_2*-0.0541298) + (perceptron_layer_1_output_3*-0.944963) + (perceptron_layer_1_output_4*-0.326611) + (perceptron_layer_1_output_5*0.520292) + (perceptron_layer_1_output_6*0.203906) + (perceptron_layer_1_output_7*-0.52843) )
		perceptron_layer_2_output_3 = np.tanh( 0.376514 + (perceptron_layer_1_output_0*0.567629) + (perceptron_layer_1_output_1*-0.747734) + (perceptron_layer_1_output_2*-0.329806) + (perceptron_layer_1_output_3*0.410157) + (perceptron_layer_1_output_4*1.6795) + (perceptron_layer_1_output_5*-0.441997) + (perceptron_layer_1_output_6*0.345783) + (perceptron_layer_1_output_7*-0.316622) )
		perceptron_layer_2_output_4 = np.tanh( -0.776829 + (perceptron_layer_1_output_0*-0.602354) + (perceptron_layer_1_output_1*-2.08548) + (perceptron_layer_1_output_2*-1.43555) + (perceptron_layer_1_output_3*0.832632) + (perceptron_layer_1_output_4*0.996648) + (perceptron_layer_1_output_5*0.977009) + (perceptron_layer_1_output_6*0.114804) + (perceptron_layer_1_output_7*-1.47192) )
		perceptron_layer_2_output_5 = np.tanh( -0.504522 + (perceptron_layer_1_output_0*-0.797661) + (perceptron_layer_1_output_1*0.651506) + (perceptron_layer_1_output_2*-0.127894) + (perceptron_layer_1_output_3*-0.964948) + (perceptron_layer_1_output_4*-0.223457) + (perceptron_layer_1_output_5*1.16115) + (perceptron_layer_1_output_6*0.7682) + (perceptron_layer_1_output_7*-1.04126) )
		perceptron_layer_2_output_6 = np.tanh( 0.566725 + (perceptron_layer_1_output_0*-1.05685) + (perceptron_layer_1_output_1*0.44352) + (perceptron_layer_1_output_2*0.774067) + (perceptron_layer_1_output_3*-0.170649) + (perceptron_layer_1_output_4*0.568597) + (perceptron_layer_1_output_5*-1.12644) + (perceptron_layer_1_output_6*0.578876) + (perceptron_layer_1_output_7*1.36878) )
		perceptron_layer_2_output_7 = np.tanh( -0.746104 + (perceptron_layer_1_output_0*-0.923176) + (perceptron_layer_1_output_1*-0.736328) + (perceptron_layer_1_output_2*-0.661435) + (perceptron_layer_1_output_3*0.9807) + (perceptron_layer_1_output_4*0.284005) + (perceptron_layer_1_output_5*0.00896116) + (perceptron_layer_1_output_6*-0.350275) + (perceptron_layer_1_output_7*-0.378631) )
		
		perceptron_layer_3_output_0 = np.tanh( -0.336616 + (perceptron_layer_2_output_0*0.36393) + (perceptron_layer_2_output_1*0.400064) + (perceptron_layer_2_output_2*0.573654) + (perceptron_layer_2_output_3*0.822749) + (perceptron_layer_2_output_4*-0.663672) + (perceptron_layer_2_output_5*-0.223512) + (perceptron_layer_2_output_6*0.322163) + (perceptron_layer_2_output_7*0.00838716) )
		perceptron_layer_3_output_1 = np.tanh( 0.452701 + (perceptron_layer_2_output_0*1.04627) + (perceptron_layer_2_output_1*-0.398691) + (perceptron_layer_2_output_2*1.09695) + (perceptron_layer_2_output_3*0.660124) + (perceptron_layer_2_output_4*1.02065) + (perceptron_layer_2_output_5*1.32614) + (perceptron_layer_2_output_6*0.303199) + (perceptron_layer_2_output_7*0.32328) )
		perceptron_layer_3_output_2 = np.tanh( 0.297975 + (perceptron_layer_2_output_0*-0.186959) + (perceptron_layer_2_output_1*0.7413) + (perceptron_layer_2_output_2*3.01224) + (perceptron_layer_2_output_3*0.310611) + (perceptron_layer_2_output_4*0.380587) + (perceptron_layer_2_output_5*-0.706897) + (perceptron_layer_2_output_6*1.01324) + (perceptron_layer_2_output_7*0.787994) )
		perceptron_layer_3_output_3 = np.tanh( -1.24202 + (perceptron_layer_2_output_0*-2.10262) + (perceptron_layer_2_output_1*-0.088172) + (perceptron_layer_2_output_2*-5.45924) + (perceptron_layer_2_output_3*-1.33036) + (perceptron_layer_2_output_4*-0.758618) + (perceptron_layer_2_output_5*-1.42558) + (perceptron_layer_2_output_6*-1.63417) + (perceptron_layer_2_output_7*-2.26757) )
		perceptron_layer_3_output_4 = np.tanh( -0.70764 + (perceptron_layer_2_output_0*-1.48776) + (perceptron_layer_2_output_1*1.89027) + (perceptron_layer_2_output_2*-2.46602) + (perceptron_layer_2_output_3*-0.644957) + (perceptron_layer_2_output_4*-0.570471) + (perceptron_layer_2_output_5*-0.283461) + (perceptron_layer_2_output_6*-0.155017) + (perceptron_layer_2_output_7*-1.38396) )
		perceptron_layer_3_output_5 = np.tanh( -0.622844 + (perceptron_layer_2_output_0*0.303087) + (perceptron_layer_2_output_1*0.191183) + (perceptron_layer_2_output_2*-0.196631) + (perceptron_layer_2_output_3*0.0853286) + (perceptron_layer_2_output_4*-0.108399) + (perceptron_layer_2_output_5*0.441781) + (perceptron_layer_2_output_6*0.476115) + (perceptron_layer_2_output_7*-0.606729) )
		perceptron_layer_3_output_6 = np.tanh( 1.18921 + (perceptron_layer_2_output_0*-0.256651) + (perceptron_layer_2_output_1*0.169717) + (perceptron_layer_2_output_2*-0.243003) + (perceptron_layer_2_output_3*0.294731) + (perceptron_layer_2_output_4*-0.953613) + (perceptron_layer_2_output_5*-0.158235) + (perceptron_layer_2_output_6*0.243217) + (perceptron_layer_2_output_7*0.547588) )
		perceptron_layer_3_output_7 = np.tanh( -0.971192 + (perceptron_layer_2_output_0*-0.221221) + (perceptron_layer_2_output_1*-0.420626) + (perceptron_layer_2_output_2*-1.56002) + (perceptron_layer_2_output_3*-0.761258) + (perceptron_layer_2_output_4*0.160866) + (perceptron_layer_2_output_5*-0.188258) + (perceptron_layer_2_output_6*0.444817) + (perceptron_layer_2_output_7*-1.9623) )
		
		perceptron_layer_4_output_0 = np.tanh( 0.30271 + (perceptron_layer_3_output_0*3.65725) + (perceptron_layer_3_output_1*3.10076) + (perceptron_layer_3_output_2*-2.88605) + (perceptron_layer_3_output_3*-1.43115) + (perceptron_layer_3_output_4*-0.0498788) + (perceptron_layer_3_output_5*-4.00369) + (perceptron_layer_3_output_6*-2.42913) + (perceptron_layer_3_output_7*0.947157) )
		perceptron_layer_4_output_1 = np.tanh( 0.0578284 + (perceptron_layer_3_output_0*-0.041968) + (perceptron_layer_3_output_1*1.21105) + (perceptron_layer_3_output_2*-0.797626) + (perceptron_layer_3_output_3*-0.41894) + (perceptron_layer_3_output_4*-0.926129) + (perceptron_layer_3_output_5*-0.93171) + (perceptron_layer_3_output_6*-1.20028) + (perceptron_layer_3_output_7*-0.282205) )
		perceptron_layer_4_output_2 = np.tanh( 0.632303 + (perceptron_layer_3_output_0*2.93956) + (perceptron_layer_3_output_1*2.57147) + (perceptron_layer_3_output_2*-3.97949) + (perceptron_layer_3_output_3*0.238618) + (perceptron_layer_3_output_4*-0.72767) + (perceptron_layer_3_output_5*-3.49226) + (perceptron_layer_3_output_6*-1.20342) + (perceptron_layer_3_output_7*1.11319) )
		perceptron_layer_4_output_3 = np.tanh( 0.393624 + (perceptron_layer_3_output_0*2.9222) + (perceptron_layer_3_output_1*2.38364) + (perceptron_layer_3_output_2*-2.64758) + (perceptron_layer_3_output_3*1.09798) + (perceptron_layer_3_output_4*-1.49) + (perceptron_layer_3_output_5*-4.12216) + (perceptron_layer_3_output_6*-1.9911) + (perceptron_layer_3_output_7*0.18253) )
		perceptron_layer_4_output_4 = np.tanh( 0.0802506 + (perceptron_layer_3_output_0*0.301088) + (perceptron_layer_3_output_1*0.236607) + (perceptron_layer_3_output_2*-0.324861) + (perceptron_layer_3_output_3*-0.180386) + (perceptron_layer_3_output_4*0.359014) + (perceptron_layer_3_output_5*-0.466347) + (perceptron_layer_3_output_6*-0.472961) + (perceptron_layer_3_output_7*0.346176) )
		perceptron_layer_4_output_5 = np.tanh( -0.948323 + (perceptron_layer_3_output_0*0.37418) + (perceptron_layer_3_output_1*-0.151595) + (perceptron_layer_3_output_2*0.440479) + (perceptron_layer_3_output_3*0.504055) + (perceptron_layer_3_output_4*-0.618229) + (perceptron_layer_3_output_5*0.653013) + (perceptron_layer_3_output_6*0.639036) + (perceptron_layer_3_output_7*-0.800546) )
		perceptron_layer_4_output_6 = np.tanh( 0.453794 + (perceptron_layer_3_output_0*0.326241) + (perceptron_layer_3_output_1*-1.23293) + (perceptron_layer_3_output_2*0.894834) + (perceptron_layer_3_output_3*0.205175) + (perceptron_layer_3_output_4*0.214564) + (perceptron_layer_3_output_5*1.25205) + (perceptron_layer_3_output_6*0.407732) + (perceptron_layer_3_output_7*-0.201639) )
		perceptron_layer_4_output_7 = np.tanh( -0.0446967 + (perceptron_layer_3_output_0*-2.01741) + (perceptron_layer_3_output_1*-1.58242) + (perceptron_layer_3_output_2*1.31781) + (perceptron_layer_3_output_3*0.353531) + (perceptron_layer_3_output_4*0.399983) + (perceptron_layer_3_output_5*0.535314) + (perceptron_layer_3_output_6*0.668486) + (perceptron_layer_3_output_7*0.140477) )
		
		perceptron_layer_5_output_0 = ( 1.75268 + (perceptron_layer_4_output_0*4.06735) + (perceptron_layer_4_output_1*-2.03843) + (perceptron_layer_4_output_2*2.37023) + (perceptron_layer_4_output_3*-3.02997) + (perceptron_layer_4_output_4*-0.533993) + (perceptron_layer_4_output_5*5.8041) + (perceptron_layer_4_output_6*-2.47241) + (perceptron_layer_4_output_7*4.64994) )
		
		unscaling_layer_output_0=perceptron_layer_5_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
