import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( -0.128489 + (scaled_cement*-1.68489) + (scaled_fine_aggregate*-2.30484) + (scaled_coarse_aggregate*-1.80583) + (scaled_wc*1.26659) )
		perceptron_layer_1_output_1 = np.tanh( -0.673534 + (scaled_cement*-2.03648) + (scaled_fine_aggregate*0.351113) + (scaled_coarse_aggregate*-0.105945) + (scaled_wc*-1.93916) )
		perceptron_layer_1_output_2 = np.tanh( 0.258293 + (scaled_cement*1.33668) + (scaled_fine_aggregate*-0.793354) + (scaled_coarse_aggregate*0.211107) + (scaled_wc*-0.416984) )
		perceptron_layer_1_output_3 = np.tanh( 1.55032 + (scaled_cement*0.168375) + (scaled_fine_aggregate*-0.458716) + (scaled_coarse_aggregate*0.156712) + (scaled_wc*1.46289) )
		perceptron_layer_1_output_4 = np.tanh( -1.98286 + (scaled_cement*1.1815) + (scaled_fine_aggregate*2.05191) + (scaled_coarse_aggregate*1.28443) + (scaled_wc*-1.27822) )
		perceptron_layer_1_output_5 = np.tanh( -3.07034 + (scaled_cement*2.11092) + (scaled_fine_aggregate*-3.6448) + (scaled_coarse_aggregate*-1.86358) + (scaled_wc*-1.49232) )
		perceptron_layer_1_output_6 = np.tanh( 2.63604 + (scaled_cement*-2.15911) + (scaled_fine_aggregate*2.31556) + (scaled_coarse_aggregate*-0.242271) + (scaled_wc*0.435987) )
		perceptron_layer_1_output_7 = np.tanh( 2.30503 + (scaled_cement*0.468332) + (scaled_fine_aggregate*0.96775) + (scaled_coarse_aggregate*-2.14509) + (scaled_wc*0.331347) )
		
		perceptron_layer_2_output_0 = np.tanh( 0.890982 + (perceptron_layer_1_output_0*-0.472737) + (perceptron_layer_1_output_1*-0.320187) + (perceptron_layer_1_output_2*1.48356) + (perceptron_layer_1_output_3*0.378108) + (perceptron_layer_1_output_4*0.0740938) + (perceptron_layer_1_output_5*0.78062) + (perceptron_layer_1_output_6*-0.884717) + (perceptron_layer_1_output_7*-0.844798) )
		perceptron_layer_2_output_1 = np.tanh( 1.11552 + (perceptron_layer_1_output_0*-0.311012) + (perceptron_layer_1_output_1*-2.16136) + (perceptron_layer_1_output_2*-0.508997) + (perceptron_layer_1_output_3*-1.37221) + (perceptron_layer_1_output_4*1.46717) + (perceptron_layer_1_output_5*-2.4091) + (perceptron_layer_1_output_6*-2.47746) + (perceptron_layer_1_output_7*0.330653) )
		perceptron_layer_2_output_2 = np.tanh( 1.06977 + (perceptron_layer_1_output_0*1.26565) + (perceptron_layer_1_output_1*-0.0337728) + (perceptron_layer_1_output_2*-0.250462) + (perceptron_layer_1_output_3*2.07892) + (perceptron_layer_1_output_4*0.719147) + (perceptron_layer_1_output_5*-1.78261) + (perceptron_layer_1_output_6*0.660203) + (perceptron_layer_1_output_7*-1.84821) )
		perceptron_layer_2_output_3 = np.tanh( 0.399376 + (perceptron_layer_1_output_0*-1.38375) + (perceptron_layer_1_output_1*1.09395) + (perceptron_layer_1_output_2*1.07589) + (perceptron_layer_1_output_3*-1.39576) + (perceptron_layer_1_output_4*-0.833337) + (perceptron_layer_1_output_5*1.27163) + (perceptron_layer_1_output_6*-0.921516) + (perceptron_layer_1_output_7*-1.87736) )
		perceptron_layer_2_output_4 = np.tanh( 0.207732 + (perceptron_layer_1_output_0*-0.484273) + (perceptron_layer_1_output_1*-1.55159) + (perceptron_layer_1_output_2*0.0742863) + (perceptron_layer_1_output_3*-0.141082) + (perceptron_layer_1_output_4*-0.543249) + (perceptron_layer_1_output_5*0.741053) + (perceptron_layer_1_output_6*-1.17684) + (perceptron_layer_1_output_7*1.25842) )
		perceptron_layer_2_output_5 = np.tanh( -0.624216 + (perceptron_layer_1_output_0*-1.69383) + (perceptron_layer_1_output_1*1.3951) + (perceptron_layer_1_output_2*-0.961991) + (perceptron_layer_1_output_3*-1.60754) + (perceptron_layer_1_output_4*0.892716) + (perceptron_layer_1_output_5*0.900417) + (perceptron_layer_1_output_6*0.469288) + (perceptron_layer_1_output_7*-1.53218) )
		perceptron_layer_2_output_6 = np.tanh( -1.34064 + (perceptron_layer_1_output_0*0.826579) + (perceptron_layer_1_output_1*-1.87148) + (perceptron_layer_1_output_2*0.964808) + (perceptron_layer_1_output_3*-0.803446) + (perceptron_layer_1_output_4*-1.02518) + (perceptron_layer_1_output_5*-1.23151) + (perceptron_layer_1_output_6*0.1421) + (perceptron_layer_1_output_7*-0.602356) )
		perceptron_layer_2_output_7 = np.tanh( 0.0211509 + (perceptron_layer_1_output_0*0.702444) + (perceptron_layer_1_output_1*-0.681039) + (perceptron_layer_1_output_2*1.90796) + (perceptron_layer_1_output_3*0.105514) + (perceptron_layer_1_output_4*0.409878) + (perceptron_layer_1_output_5*0.248488) + (perceptron_layer_1_output_6*0.634893) + (perceptron_layer_1_output_7*-2.7177) )
		
		perceptron_layer_3_output_0 = np.tanh( -0.364156 + (perceptron_layer_2_output_0*-0.441939) + (perceptron_layer_2_output_1*-1.21965) + (perceptron_layer_2_output_2*0.366776) + (perceptron_layer_2_output_3*-1.12176) + (perceptron_layer_2_output_4*-0.115313) + (perceptron_layer_2_output_5*1.03035) + (perceptron_layer_2_output_6*1.10084) + (perceptron_layer_2_output_7*0.823448) )
		perceptron_layer_3_output_1 = np.tanh( -0.259012 + (perceptron_layer_2_output_0*-0.57236) + (perceptron_layer_2_output_1*-0.121845) + (perceptron_layer_2_output_2*-0.0325898) + (perceptron_layer_2_output_3*0.121505) + (perceptron_layer_2_output_4*-0.604209) + (perceptron_layer_2_output_5*-0.480456) + (perceptron_layer_2_output_6*0.966261) + (perceptron_layer_2_output_7*-0.490512) )
		perceptron_layer_3_output_2 = np.tanh( 1.22653 + (perceptron_layer_2_output_0*0.664406) + (perceptron_layer_2_output_1*-0.459267) + (perceptron_layer_2_output_2*-0.164911) + (perceptron_layer_2_output_3*-0.712759) + (perceptron_layer_2_output_4*1.48917) + (perceptron_layer_2_output_5*-0.593189) + (perceptron_layer_2_output_6*-0.283174) + (perceptron_layer_2_output_7*-0.77409) )
		perceptron_layer_3_output_3 = np.tanh( 0.413124 + (perceptron_layer_2_output_0*-0.510293) + (perceptron_layer_2_output_1*-0.275833) + (perceptron_layer_2_output_2*-0.192037) + (perceptron_layer_2_output_3*0.354605) + (perceptron_layer_2_output_4*0.276188) + (perceptron_layer_2_output_5*-0.893789) + (perceptron_layer_2_output_6*-0.541403) + (perceptron_layer_2_output_7*1.5104) )
		perceptron_layer_3_output_4 = np.tanh( -0.385758 + (perceptron_layer_2_output_0*1.27524) + (perceptron_layer_2_output_1*-2.28488) + (perceptron_layer_2_output_2*-1.24633) + (perceptron_layer_2_output_3*-0.274131) + (perceptron_layer_2_output_4*-2.16025) + (perceptron_layer_2_output_5*1.97489) + (perceptron_layer_2_output_6*2.45995) + (perceptron_layer_2_output_7*-1.61654) )
		perceptron_layer_3_output_5 = np.tanh( 0.370358 + (perceptron_layer_2_output_0*-0.520298) + (perceptron_layer_2_output_1*0.709262) + (perceptron_layer_2_output_2*1.47099) + (perceptron_layer_2_output_3*-2.85816) + (perceptron_layer_2_output_4*0.402757) + (perceptron_layer_2_output_5*-1.79817) + (perceptron_layer_2_output_6*-1.40828) + (perceptron_layer_2_output_7*-0.195564) )
		perceptron_layer_3_output_6 = np.tanh( -0.486454 + (perceptron_layer_2_output_0*0.106915) + (perceptron_layer_2_output_1*-1.11731) + (perceptron_layer_2_output_2*-0.560792) + (perceptron_layer_2_output_3*0.968676) + (perceptron_layer_2_output_4*0.296186) + (perceptron_layer_2_output_5*-0.0363424) + (perceptron_layer_2_output_6*0.247797) + (perceptron_layer_2_output_7*-0.644412) )
		perceptron_layer_3_output_7 = np.tanh( 0.716948 + (perceptron_layer_2_output_0*0.197367) + (perceptron_layer_2_output_1*-1.07622) + (perceptron_layer_2_output_2*0.408379) + (perceptron_layer_2_output_3*0.740307) + (perceptron_layer_2_output_4*-0.23489) + (perceptron_layer_2_output_5*1.03786) + (perceptron_layer_2_output_6*-0.481524) + (perceptron_layer_2_output_7*-0.205243) )
		
		perceptron_layer_4_output_0 = np.tanh( -0.584375 + (perceptron_layer_3_output_0*-0.49984) + (perceptron_layer_3_output_1*-0.619921) + (perceptron_layer_3_output_2*0.0616705) + (perceptron_layer_3_output_3*-0.304521) + (perceptron_layer_3_output_4*-2.46096) + (perceptron_layer_3_output_5*0.639079) + (perceptron_layer_3_output_6*0.196954) + (perceptron_layer_3_output_7*0.725304) )
		perceptron_layer_4_output_1 = np.tanh( -0.782998 + (perceptron_layer_3_output_0*-0.824072) + (perceptron_layer_3_output_1*0.583313) + (perceptron_layer_3_output_2*-0.25294) + (perceptron_layer_3_output_3*0.272689) + (perceptron_layer_3_output_4*-0.112275) + (perceptron_layer_3_output_5*-0.106275) + (perceptron_layer_3_output_6*0.230695) + (perceptron_layer_3_output_7*-0.477331) )
		perceptron_layer_4_output_2 = np.tanh( -0.0868602 + (perceptron_layer_3_output_0*-0.00955672) + (perceptron_layer_3_output_1*-0.136773) + (perceptron_layer_3_output_2*-0.761218) + (perceptron_layer_3_output_3*0.179093) + (perceptron_layer_3_output_4*-1.0081) + (perceptron_layer_3_output_5*0.784459) + (perceptron_layer_3_output_6*0.1248) + (perceptron_layer_3_output_7*0.305917) )
		perceptron_layer_4_output_3 = np.tanh( -0.414478 + (perceptron_layer_3_output_0*-0.150294) + (perceptron_layer_3_output_1*0.119286) + (perceptron_layer_3_output_2*-0.0984223) + (perceptron_layer_3_output_3*0.542888) + (perceptron_layer_3_output_4*-0.354043) + (perceptron_layer_3_output_5*0.537431) + (perceptron_layer_3_output_6*0.484681) + (perceptron_layer_3_output_7*-0.391325) )
		perceptron_layer_4_output_4 = np.tanh( 0.487828 + (perceptron_layer_3_output_0*0.274061) + (perceptron_layer_3_output_1*-0.873428) + (perceptron_layer_3_output_2*0.458942) + (perceptron_layer_3_output_3*-0.294588) + (perceptron_layer_3_output_4*0.49584) + (perceptron_layer_3_output_5*-0.238555) + (perceptron_layer_3_output_6*-0.382117) + (perceptron_layer_3_output_7*0.105598) )
		perceptron_layer_4_output_5 = np.tanh( 0.441997 + (perceptron_layer_3_output_0*-0.598395) + (perceptron_layer_3_output_1*-0.670658) + (perceptron_layer_3_output_2*-0.755365) + (perceptron_layer_3_output_3*-1.4674) + (perceptron_layer_3_output_4*-1.03991) + (perceptron_layer_3_output_5*1.03754) + (perceptron_layer_3_output_6*0.232227) + (perceptron_layer_3_output_7*0.997804) )
		perceptron_layer_4_output_6 = np.tanh( 0.493989 + (perceptron_layer_3_output_0*0.586187) + (perceptron_layer_3_output_1*-0.0270594) + (perceptron_layer_3_output_2*0.160773) + (perceptron_layer_3_output_3*0.773244) + (perceptron_layer_3_output_4*1.47847) + (perceptron_layer_3_output_5*-1.30737) + (perceptron_layer_3_output_6*-0.0767608) + (perceptron_layer_3_output_7*-1.13127) )
		perceptron_layer_4_output_7 = np.tanh( 0.228193 + (perceptron_layer_3_output_0*-0.978153) + (perceptron_layer_3_output_1*0.142465) + (perceptron_layer_3_output_2*0.697379) + (perceptron_layer_3_output_3*-0.083708) + (perceptron_layer_3_output_4*-1.66717) + (perceptron_layer_3_output_5*-0.634887) + (perceptron_layer_3_output_6*0.724139) + (perceptron_layer_3_output_7*0.315371) )
		
		perceptron_layer_5_output_0 = np.tanh( 0.400116 + (perceptron_layer_4_output_0*-0.290495) + (perceptron_layer_4_output_1*-0.204584) + (perceptron_layer_4_output_2*-0.666526) + (perceptron_layer_4_output_3*-0.221071) + (perceptron_layer_4_output_4*0.167979) + (perceptron_layer_4_output_5*-1.14563) + (perceptron_layer_4_output_6*0.0437521) + (perceptron_layer_4_output_7*-0.626585) )
		perceptron_layer_5_output_1 = np.tanh( -0.314276 + (perceptron_layer_4_output_0*0.771954) + (perceptron_layer_4_output_1*0.313344) + (perceptron_layer_4_output_2*0.0456036) + (perceptron_layer_4_output_3*0.0116726) + (perceptron_layer_4_output_4*-0.253031) + (perceptron_layer_4_output_5*-0.24455) + (perceptron_layer_4_output_6*-0.683924) + (perceptron_layer_4_output_7*-0.220103) )
		perceptron_layer_5_output_2 = np.tanh( 0.2701 + (perceptron_layer_4_output_0*-0.574815) + (perceptron_layer_4_output_1*-0.226806) + (perceptron_layer_4_output_2*0.210749) + (perceptron_layer_4_output_3*-0.0729741) + (perceptron_layer_4_output_4*0.00152525) + (perceptron_layer_4_output_5*-0.117848) + (perceptron_layer_4_output_6*0.413668) + (perceptron_layer_4_output_7*0.223015) )
		perceptron_layer_5_output_3 = np.tanh( 0.652776 + (perceptron_layer_4_output_0*1.27951) + (perceptron_layer_4_output_1*-0.128997) + (perceptron_layer_4_output_2*1.00582) + (perceptron_layer_4_output_3*0.337183) + (perceptron_layer_4_output_4*-0.202281) + (perceptron_layer_4_output_5*1.24167) + (perceptron_layer_4_output_6*-0.812637) + (perceptron_layer_4_output_7*0.964334) )
		perceptron_layer_5_output_4 = np.tanh( -0.26581 + (perceptron_layer_4_output_0*0.780564) + (perceptron_layer_4_output_1*0.418958) + (perceptron_layer_4_output_2*0.208858) + (perceptron_layer_4_output_3*0.159032) + (perceptron_layer_4_output_4*-0.162957) + (perceptron_layer_4_output_5*-0.303044) + (perceptron_layer_4_output_6*-0.644437) + (perceptron_layer_4_output_7*-0.241335) )
		perceptron_layer_5_output_5 = np.tanh( -0.301899 + (perceptron_layer_4_output_0*0.689251) + (perceptron_layer_4_output_1*0.260848) + (perceptron_layer_4_output_2*0.119403) + (perceptron_layer_4_output_3*0.241247) + (perceptron_layer_4_output_4*-0.4542) + (perceptron_layer_4_output_5*-0.294481) + (perceptron_layer_4_output_6*-0.549847) + (perceptron_layer_4_output_7*-0.420207) )
		perceptron_layer_5_output_6 = np.tanh( -0.355505 + (perceptron_layer_4_output_0*0.933138) + (perceptron_layer_4_output_1*0.424725) + (perceptron_layer_4_output_2*0.276994) + (perceptron_layer_4_output_3*0.0696056) + (perceptron_layer_4_output_4*-0.383292) + (perceptron_layer_4_output_5*0.082446) + (perceptron_layer_4_output_6*-0.92765) + (perceptron_layer_4_output_7*-0.017166) )
		perceptron_layer_5_output_7 = np.tanh( 0.00301181 + (perceptron_layer_4_output_0*0.17139) + (perceptron_layer_4_output_1*0.037418) + (perceptron_layer_4_output_2*-0.23075) + (perceptron_layer_4_output_3*-0.145593) + (perceptron_layer_4_output_4*-0.121618) + (perceptron_layer_4_output_5*-0.0776701) + (perceptron_layer_4_output_6*0.131781) + (perceptron_layer_4_output_7*-0.198599) )
		
		perceptron_layer_6_output_0 = ( -0.957445 + (perceptron_layer_5_output_0*-0.858492) + (perceptron_layer_5_output_1*-0.870048) + (perceptron_layer_5_output_2*0.376992) + (perceptron_layer_5_output_3*1.54366) + (perceptron_layer_5_output_4*-0.885975) + (perceptron_layer_5_output_5*-0.884925) + (perceptron_layer_5_output_6*-0.85137) + (perceptron_layer_5_output_7*0.177184) )
		
		unscaling_layer_output_0=perceptron_layer_6_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
