import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( 0.590861 + (scaled_cement*0.00973213) + (scaled_fine_aggregate*-0.19049) + (scaled_coarse_aggregate*0.0699844) + (scaled_wc*1.6842) )
		perceptron_layer_1_output_1 = np.tanh( 1.02613 + (scaled_cement*-1.90601) + (scaled_fine_aggregate*-0.588208) + (scaled_coarse_aggregate*-1.31375) + (scaled_wc*4.14339) )
		perceptron_layer_1_output_2 = np.tanh( -1.66991 + (scaled_cement*-1.37514) + (scaled_fine_aggregate*-2.58277) + (scaled_coarse_aggregate*-3.12755) + (scaled_wc*-1.57281) )
		perceptron_layer_1_output_3 = np.tanh( -1.27021 + (scaled_cement*-2.50998) + (scaled_fine_aggregate*-0.476534) + (scaled_coarse_aggregate*-0.994028) + (scaled_wc*0.0100522) )
		perceptron_layer_1_output_4 = np.tanh( 0.49568 + (scaled_cement*-2.22629) + (scaled_fine_aggregate*0.0101364) + (scaled_coarse_aggregate*0.515472) + (scaled_wc*1.84383) )
		perceptron_layer_1_output_5 = np.tanh( -0.0114977 + (scaled_cement*1.65663) + (scaled_fine_aggregate*0.324814) + (scaled_coarse_aggregate*-0.247359) + (scaled_wc*2.1253) )
		perceptron_layer_1_output_6 = np.tanh( 0.282326 + (scaled_cement*-2.06239) + (scaled_fine_aggregate*-0.573028) + (scaled_coarse_aggregate*-1.48475) + (scaled_wc*-1.06915) )
		perceptron_layer_1_output_7 = np.tanh( 0.304739 + (scaled_cement*0.209922) + (scaled_fine_aggregate*0.142842) + (scaled_coarse_aggregate*0.140544) + (scaled_wc*0.569379) )
		
		perceptron_layer_2_output_0 = np.tanh( 1.32315 + (perceptron_layer_1_output_0*-2.07453) + (perceptron_layer_1_output_1*-1.47343) + (perceptron_layer_1_output_2*0.77662) + (perceptron_layer_1_output_3*0.0599224) + (perceptron_layer_1_output_4*-0.164305) + (perceptron_layer_1_output_5*-0.502141) + (perceptron_layer_1_output_6*2.49344) + (perceptron_layer_1_output_7*0.875695) )
		perceptron_layer_2_output_1 = np.tanh( 1.01242 + (perceptron_layer_1_output_0*-0.410551) + (perceptron_layer_1_output_1*-1.54759) + (perceptron_layer_1_output_2*-0.954431) + (perceptron_layer_1_output_3*-1.4269) + (perceptron_layer_1_output_4*-0.862796) + (perceptron_layer_1_output_5*-0.377087) + (perceptron_layer_1_output_6*0.932325) + (perceptron_layer_1_output_7*-0.170459) )
		perceptron_layer_2_output_2 = np.tanh( 1.13014 + (perceptron_layer_1_output_0*0.659637) + (perceptron_layer_1_output_1*-0.862323) + (perceptron_layer_1_output_2*1.34521) + (perceptron_layer_1_output_3*-0.66069) + (perceptron_layer_1_output_4*-1.31782) + (perceptron_layer_1_output_5*0.121714) + (perceptron_layer_1_output_6*0.261612) + (perceptron_layer_1_output_7*0.408027) )
		perceptron_layer_2_output_3 = np.tanh( 0.248085 + (perceptron_layer_1_output_0*0.0937078) + (perceptron_layer_1_output_1*0.805831) + (perceptron_layer_1_output_2*-1.94363) + (perceptron_layer_1_output_3*1.32205) + (perceptron_layer_1_output_4*0.51194) + (perceptron_layer_1_output_5*-0.756239) + (perceptron_layer_1_output_6*0.535645) + (perceptron_layer_1_output_7*0.214009) )
		perceptron_layer_2_output_4 = np.tanh( 0.795574 + (perceptron_layer_1_output_0*1.19195) + (perceptron_layer_1_output_1*0.814749) + (perceptron_layer_1_output_2*1.00114) + (perceptron_layer_1_output_3*-0.51857) + (perceptron_layer_1_output_4*-0.341748) + (perceptron_layer_1_output_5*0.71689) + (perceptron_layer_1_output_6*0.555071) + (perceptron_layer_1_output_7*1.7197) )
		perceptron_layer_2_output_5 = np.tanh( -1.00798 + (perceptron_layer_1_output_0*2.47657) + (perceptron_layer_1_output_1*-1.01482) + (perceptron_layer_1_output_2*-0.714876) + (perceptron_layer_1_output_3*-0.750469) + (perceptron_layer_1_output_4*-1.21613) + (perceptron_layer_1_output_5*-0.0659259) + (perceptron_layer_1_output_6*0.153876) + (perceptron_layer_1_output_7*2.03704) )
		perceptron_layer_2_output_6 = np.tanh( -0.670882 + (perceptron_layer_1_output_0*-0.907499) + (perceptron_layer_1_output_1*-1.36554) + (perceptron_layer_1_output_2*-0.637538) + (perceptron_layer_1_output_3*1.49707) + (perceptron_layer_1_output_4*-0.112267) + (perceptron_layer_1_output_5*-1.40493) + (perceptron_layer_1_output_6*0.876622) + (perceptron_layer_1_output_7*0.30626) )
		perceptron_layer_2_output_7 = np.tanh( -1.4374 + (perceptron_layer_1_output_0*1.74715) + (perceptron_layer_1_output_1*-0.156853) + (perceptron_layer_1_output_2*-0.250508) + (perceptron_layer_1_output_3*0.0918991) + (perceptron_layer_1_output_4*0.852941) + (perceptron_layer_1_output_5*0.326714) + (perceptron_layer_1_output_6*0.768188) + (perceptron_layer_1_output_7*0.37901) )
		
		perceptron_layer_3_output_0 = np.tanh( 0.582096 + (perceptron_layer_2_output_0*-0.599176) + (perceptron_layer_2_output_1*0.908799) + (perceptron_layer_2_output_2*-0.854638) + (perceptron_layer_2_output_3*-0.31503) + (perceptron_layer_2_output_4*-1.26317) + (perceptron_layer_2_output_5*-1.28806) + (perceptron_layer_2_output_6*1.62307) + (perceptron_layer_2_output_7*-0.385122) )
		perceptron_layer_3_output_1 = np.tanh( -1.03172 + (perceptron_layer_2_output_0*-0.180878) + (perceptron_layer_2_output_1*-0.164775) + (perceptron_layer_2_output_2*-0.597612) + (perceptron_layer_2_output_3*-0.0422702) + (perceptron_layer_2_output_4*-0.429941) + (perceptron_layer_2_output_5*-0.264909) + (perceptron_layer_2_output_6*-1.1832) + (perceptron_layer_2_output_7*-0.666928) )
		perceptron_layer_3_output_2 = np.tanh( -0.322951 + (perceptron_layer_2_output_0*0.149063) + (perceptron_layer_2_output_1*1.26726) + (perceptron_layer_2_output_2*-0.0497443) + (perceptron_layer_2_output_3*-0.642739) + (perceptron_layer_2_output_4*-0.257598) + (perceptron_layer_2_output_5*-0.185219) + (perceptron_layer_2_output_6*1.00207) + (perceptron_layer_2_output_7*0.497049) )
		perceptron_layer_3_output_3 = np.tanh( 0.547825 + (perceptron_layer_2_output_0*0.646569) + (perceptron_layer_2_output_1*1.51034) + (perceptron_layer_2_output_2*-0.314132) + (perceptron_layer_2_output_3*-0.237132) + (perceptron_layer_2_output_4*-0.513461) + (perceptron_layer_2_output_5*0.433905) + (perceptron_layer_2_output_6*0.442685) + (perceptron_layer_2_output_7*-0.970113) )
		perceptron_layer_3_output_4 = np.tanh( -0.192303 + (perceptron_layer_2_output_0*0.619704) + (perceptron_layer_2_output_1*1.80096) + (perceptron_layer_2_output_2*0.288203) + (perceptron_layer_2_output_3*-1.32621) + (perceptron_layer_2_output_4*-0.0460683) + (perceptron_layer_2_output_5*-0.441313) + (perceptron_layer_2_output_6*1.23571) + (perceptron_layer_2_output_7*0.0213975) )
		perceptron_layer_3_output_5 = np.tanh( -0.253009 + (perceptron_layer_2_output_0*0.256389) + (perceptron_layer_2_output_1*-1.55155) + (perceptron_layer_2_output_2*-0.401089) + (perceptron_layer_2_output_3*0.131845) + (perceptron_layer_2_output_4*1.55936) + (perceptron_layer_2_output_5*1.6212) + (perceptron_layer_2_output_6*-1.17394) + (perceptron_layer_2_output_7*2.54082) )
		perceptron_layer_3_output_6 = np.tanh( 0.718482 + (perceptron_layer_2_output_0*-2.06312) + (perceptron_layer_2_output_1*-0.35886) + (perceptron_layer_2_output_2*-0.76976) + (perceptron_layer_2_output_3*-0.192072) + (perceptron_layer_2_output_4*-0.613812) + (perceptron_layer_2_output_5*-2.70701) + (perceptron_layer_2_output_6*-0.614357) + (perceptron_layer_2_output_7*-1.18074) )
		perceptron_layer_3_output_7 = np.tanh( 0.396759 + (perceptron_layer_2_output_0*-1.88272) + (perceptron_layer_2_output_1*0.0666206) + (perceptron_layer_2_output_2*-0.321408) + (perceptron_layer_2_output_3*-0.647096) + (perceptron_layer_2_output_4*-2.35515) + (perceptron_layer_2_output_5*-1.41857) + (perceptron_layer_2_output_6*0.258241) + (perceptron_layer_2_output_7*0.0276295) )
		
		perceptron_layer_4_output_0 = np.tanh( -0.222416 + (perceptron_layer_3_output_0*0.340228) + (perceptron_layer_3_output_1*0.15979) + (perceptron_layer_3_output_2*-0.951137) + (perceptron_layer_3_output_3*-0.286124) + (perceptron_layer_3_output_4*-0.758327) + (perceptron_layer_3_output_5*-0.437179) + (perceptron_layer_3_output_6*-0.364892) + (perceptron_layer_3_output_7*-1.06625) )
		perceptron_layer_4_output_1 = np.tanh( 0.829553 + (perceptron_layer_3_output_0*1.183) + (perceptron_layer_3_output_1*0.56334) + (perceptron_layer_3_output_2*-0.502398) + (perceptron_layer_3_output_3*-0.384801) + (perceptron_layer_3_output_4*-0.87275) + (perceptron_layer_3_output_5*-0.726741) + (perceptron_layer_3_output_6*0.44592) + (perceptron_layer_3_output_7*-0.229995) )
		perceptron_layer_4_output_2 = np.tanh( -0.279822 + (perceptron_layer_3_output_0*-0.629192) + (perceptron_layer_3_output_1*0.719778) + (perceptron_layer_3_output_2*0.40569) + (perceptron_layer_3_output_3*-0.647865) + (perceptron_layer_3_output_4*0.186605) + (perceptron_layer_3_output_5*0.0227721) + (perceptron_layer_3_output_6*0.288526) + (perceptron_layer_3_output_7*0.017434) )
		perceptron_layer_4_output_3 = np.tanh( 0.0901714 + (perceptron_layer_3_output_0*-0.661539) + (perceptron_layer_3_output_1*0.125965) + (perceptron_layer_3_output_2*-0.078233) + (perceptron_layer_3_output_3*1.06118) + (perceptron_layer_3_output_4*-0.876863) + (perceptron_layer_3_output_5*-1.74613) + (perceptron_layer_3_output_6*-2.8248) + (perceptron_layer_3_output_7*-1.61243) )
		perceptron_layer_4_output_4 = np.tanh( -0.205662 + (perceptron_layer_3_output_0*-0.309991) + (perceptron_layer_3_output_1*-0.283384) + (perceptron_layer_3_output_2*-0.0849296) + (perceptron_layer_3_output_3*0.100596) + (perceptron_layer_3_output_4*0.21232) + (perceptron_layer_3_output_5*0.112011) + (perceptron_layer_3_output_6*-0.374474) + (perceptron_layer_3_output_7*-0.00632821) )
		perceptron_layer_4_output_5 = np.tanh( -0.0419923 + (perceptron_layer_3_output_0*0.442967) + (perceptron_layer_3_output_1*-0.331509) + (perceptron_layer_3_output_2*0.00607689) + (perceptron_layer_3_output_3*-0.214057) + (perceptron_layer_3_output_4*-0.325731) + (perceptron_layer_3_output_5*-0.695216) + (perceptron_layer_3_output_6*0.682065) + (perceptron_layer_3_output_7*0.334914) )
		perceptron_layer_4_output_6 = np.tanh( -0.112103 + (perceptron_layer_3_output_0*-0.698365) + (perceptron_layer_3_output_1*0.112379) + (perceptron_layer_3_output_2*1.52988) + (perceptron_layer_3_output_3*0.87941) + (perceptron_layer_3_output_4*0.921716) + (perceptron_layer_3_output_5*0.821362) + (perceptron_layer_3_output_6*0.877027) + (perceptron_layer_3_output_7*1.64381) )
		perceptron_layer_4_output_7 = np.tanh( -0.634312 + (perceptron_layer_3_output_0*-0.226656) + (perceptron_layer_3_output_1*0.0753663) + (perceptron_layer_3_output_2*0.215821) + (perceptron_layer_3_output_3*0.578524) + (perceptron_layer_3_output_4*0.00922601) + (perceptron_layer_3_output_5*-1.304) + (perceptron_layer_3_output_6*-2.13977) + (perceptron_layer_3_output_7*-0.788546) )
		
		perceptron_layer_5_output_0 = np.tanh( 0.6411 + (perceptron_layer_4_output_0*-0.669673) + (perceptron_layer_4_output_1*-1.64186) + (perceptron_layer_4_output_2*-0.170565) + (perceptron_layer_4_output_3*-1.51646) + (perceptron_layer_4_output_4*0.382859) + (perceptron_layer_4_output_5*-0.77415) + (perceptron_layer_4_output_6*1.69095) + (perceptron_layer_4_output_7*-1.73466) )
		perceptron_layer_5_output_1 = np.tanh( 0.253455 + (perceptron_layer_4_output_0*0.240311) + (perceptron_layer_4_output_1*-0.0158078) + (perceptron_layer_4_output_2*-0.682977) + (perceptron_layer_4_output_3*0.954573) + (perceptron_layer_4_output_4*0.148996) + (perceptron_layer_4_output_5*0.547155) + (perceptron_layer_4_output_6*-0.348155) + (perceptron_layer_4_output_7*-0.0619347) )
		perceptron_layer_5_output_2 = np.tanh( 0.0150047 + (perceptron_layer_4_output_0*-0.138245) + (perceptron_layer_4_output_1*-0.427962) + (perceptron_layer_4_output_2*0.158687) + (perceptron_layer_4_output_3*0.404798) + (perceptron_layer_4_output_4*0.178198) + (perceptron_layer_4_output_5*0.513361) + (perceptron_layer_4_output_6*-0.19144) + (perceptron_layer_4_output_7*-0.0756194) )
		perceptron_layer_5_output_3 = np.tanh( -0.0173766 + (perceptron_layer_4_output_0*-0.395707) + (perceptron_layer_4_output_1*-0.40542) + (perceptron_layer_4_output_2*0.0787084) + (perceptron_layer_4_output_3*-0.298435) + (perceptron_layer_4_output_4*-0.257008) + (perceptron_layer_4_output_5*0.043536) + (perceptron_layer_4_output_6*0.43409) + (perceptron_layer_4_output_7*-0.14741) )
		perceptron_layer_5_output_4 = np.tanh( -0.21033 + (perceptron_layer_4_output_0*0.0190876) + (perceptron_layer_4_output_1*0.514274) + (perceptron_layer_4_output_2*-0.0776319) + (perceptron_layer_4_output_3*-0.173839) + (perceptron_layer_4_output_4*0.0888954) + (perceptron_layer_4_output_5*-0.536214) + (perceptron_layer_4_output_6*0.319477) + (perceptron_layer_4_output_7*-0.00849195) )
		perceptron_layer_5_output_5 = np.tanh( 0.599433 + (perceptron_layer_4_output_0*-0.474476) + (perceptron_layer_4_output_1*-0.357795) + (perceptron_layer_4_output_2*0.236023) + (perceptron_layer_4_output_3*-0.55952) + (perceptron_layer_4_output_4*-0.241746) + (perceptron_layer_4_output_5*0.139443) + (perceptron_layer_4_output_6*0.263039) + (perceptron_layer_4_output_7*-0.470143) )
		perceptron_layer_5_output_6 = np.tanh( 0.244825 + (perceptron_layer_4_output_0*0.335915) + (perceptron_layer_4_output_1*-0.128795) + (perceptron_layer_4_output_2*-0.435936) + (perceptron_layer_4_output_3*0.609995) + (perceptron_layer_4_output_4*0.127509) + (perceptron_layer_4_output_5*0.521178) + (perceptron_layer_4_output_6*-0.382625) + (perceptron_layer_4_output_7*0.0227423) )
		perceptron_layer_5_output_7 = np.tanh( 0.11632 + (perceptron_layer_4_output_0*0.103614) + (perceptron_layer_4_output_1*0.235265) + (perceptron_layer_4_output_2*0.00678251) + (perceptron_layer_4_output_3*-0.0511961) + (perceptron_layer_4_output_4*-0.0773327) + (perceptron_layer_4_output_5*-0.034015) + (perceptron_layer_4_output_6*0.303547) + (perceptron_layer_4_output_7*0.0629605) )
		
		perceptron_layer_6_output_0 = ( -0.247343 + (perceptron_layer_5_output_0*2.40218) + (perceptron_layer_5_output_1*1.09139) + (perceptron_layer_5_output_2*0.674766) + (perceptron_layer_5_output_3*-0.250478) + (perceptron_layer_5_output_4*-0.485299) + (perceptron_layer_5_output_5*0.0325768) + (perceptron_layer_5_output_6*0.597344) + (perceptron_layer_5_output_7*-0.200795) )
		
		unscaling_layer_output_0=perceptron_layer_6_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
