import math
import numpy as np


class BaseNeuralArchitecture:
	def __init__(self):
		self.inputs_number = 4


	def calculate_outputs(self, inputs):
		cement = inputs[0]
		fine_aggregate = inputs[1]
		coarse_aggregate = inputs[2]
		wc = inputs[3]

		scaled_cement = (cement-322.1530151)/75.92960358
		scaled_fine_aggregate = (fine_aggregate-767.9609985)/78.1352005
		scaled_coarse_aggregate = (coarse_aggregate-969.9219971)/81.24639893
		scaled_wc = (wc-0.5799070001)/0.1250150055
		
		perceptron_layer_1_output_0 = np.tanh( 0.739644 + (scaled_cement*-0.0168314) + (scaled_fine_aggregate*-0.00262018) + (scaled_coarse_aggregate*0.19038) + (scaled_wc*0.661327) )
		perceptron_layer_1_output_1 = np.tanh( -0.198147 + (scaled_cement*0.289052) + (scaled_fine_aggregate*-0.0968801) + (scaled_coarse_aggregate*-0.266271) + (scaled_wc*0.0391843) )
		perceptron_layer_1_output_2 = np.tanh( -1.46015 + (scaled_cement*-0.866588) + (scaled_fine_aggregate*-2.11916) + (scaled_coarse_aggregate*-2.61388) + (scaled_wc*-0.695483) )
		perceptron_layer_1_output_3 = np.tanh( -0.951756 + (scaled_cement*0.739956) + (scaled_fine_aggregate*1.24815) + (scaled_coarse_aggregate*0.42274) + (scaled_wc*-1.82042) )
		perceptron_layer_1_output_4 = np.tanh( -0.0387972 + (scaled_cement*1.14789) + (scaled_fine_aggregate*-0.413405) + (scaled_coarse_aggregate*-0.265149) + (scaled_wc*0.482224) )
		perceptron_layer_1_output_5 = np.tanh( 1.06786 + (scaled_cement*2.40256) + (scaled_fine_aggregate*0.492359) + (scaled_coarse_aggregate*0.990917) + (scaled_wc*1.5456) )
		perceptron_layer_1_output_6 = np.tanh( 1.00825 + (scaled_cement*-1.55178) + (scaled_fine_aggregate*-1.03524) + (scaled_coarse_aggregate*-0.336299) + (scaled_wc*6.16092) )
		perceptron_layer_1_output_7 = np.tanh( -0.492423 + (scaled_cement*3.70971) + (scaled_fine_aggregate*2.21042) + (scaled_coarse_aggregate*1.09233) + (scaled_wc*1.29833) )
		
		perceptron_layer_2_output_0 = np.tanh( -0.00968836 + (perceptron_layer_1_output_0*-1.14132) + (perceptron_layer_1_output_1*-0.993139) + (perceptron_layer_1_output_2*1.58206) + (perceptron_layer_1_output_3*2.20409) + (perceptron_layer_1_output_4*-1.72667) + (perceptron_layer_1_output_5*1.04953) + (perceptron_layer_1_output_6*2.5435) + (perceptron_layer_1_output_7*-0.265672) )
		perceptron_layer_2_output_1 = np.tanh( -0.488818 + (perceptron_layer_1_output_0*-0.279443) + (perceptron_layer_1_output_1*-0.337615) + (perceptron_layer_1_output_2*0.377868) + (perceptron_layer_1_output_3*-0.395325) + (perceptron_layer_1_output_4*0.397682) + (perceptron_layer_1_output_5*1.12817) + (perceptron_layer_1_output_6*0.215512) + (perceptron_layer_1_output_7*0.496569) )
		perceptron_layer_2_output_2 = np.tanh( 0.606654 + (perceptron_layer_1_output_0*-1.08437) + (perceptron_layer_1_output_1*-1.17821) + (perceptron_layer_1_output_2*-1.32991) + (perceptron_layer_1_output_3*2.50962) + (perceptron_layer_1_output_4*0.719229) + (perceptron_layer_1_output_5*-2.17308) + (perceptron_layer_1_output_6*2.61271) + (perceptron_layer_1_output_7*-0.370174) )
		perceptron_layer_2_output_3 = np.tanh( -0.832802 + (perceptron_layer_1_output_0*0.312792) + (perceptron_layer_1_output_1*0.0188355) + (perceptron_layer_1_output_2*-0.367481) + (perceptron_layer_1_output_3*-0.431999) + (perceptron_layer_1_output_4*-0.957208) + (perceptron_layer_1_output_5*-1.19391) + (perceptron_layer_1_output_6*0.593976) + (perceptron_layer_1_output_7*1.40561) )
		perceptron_layer_2_output_4 = np.tanh( -0.228661 + (perceptron_layer_1_output_0*0.508324) + (perceptron_layer_1_output_1*0.591194) + (perceptron_layer_1_output_2*-0.832066) + (perceptron_layer_1_output_3*-0.326287) + (perceptron_layer_1_output_4*0.431572) + (perceptron_layer_1_output_5*1.59735) + (perceptron_layer_1_output_6*-0.201339) + (perceptron_layer_1_output_7*-1.33753) )
		perceptron_layer_2_output_5 = np.tanh( -0.289921 + (perceptron_layer_1_output_0*0.326321) + (perceptron_layer_1_output_1*1.45758) + (perceptron_layer_1_output_2*-0.777069) + (perceptron_layer_1_output_3*-0.652269) + (perceptron_layer_1_output_4*-1.16682) + (perceptron_layer_1_output_5*-0.902315) + (perceptron_layer_1_output_6*1.76507) + (perceptron_layer_1_output_7*-0.38181) )
		perceptron_layer_2_output_6 = np.tanh( 0.779421 + (perceptron_layer_1_output_0*0.762418) + (perceptron_layer_1_output_1*0.581043) + (perceptron_layer_1_output_2*-1.61659) + (perceptron_layer_1_output_3*1.80366) + (perceptron_layer_1_output_4*-0.247197) + (perceptron_layer_1_output_5*-2.37933) + (perceptron_layer_1_output_6*1.86856) + (perceptron_layer_1_output_7*-0.306418) )
		perceptron_layer_2_output_7 = np.tanh( 0.242061 + (perceptron_layer_1_output_0*0.905035) + (perceptron_layer_1_output_1*1.37862) + (perceptron_layer_1_output_2*-0.284256) + (perceptron_layer_1_output_3*0.0283092) + (perceptron_layer_1_output_4*2.61967) + (perceptron_layer_1_output_5*1.6694) + (perceptron_layer_1_output_6*-1.22311) + (perceptron_layer_1_output_7*1.02504) )
		
		perceptron_layer_3_output_0 = np.tanh( 0.464702 + (perceptron_layer_2_output_0*-0.994632) + (perceptron_layer_2_output_1*0.185763) + (perceptron_layer_2_output_2*-0.720626) + (perceptron_layer_2_output_3*0.717304) + (perceptron_layer_2_output_4*-1.34809) + (perceptron_layer_2_output_5*0.381724) + (perceptron_layer_2_output_6*0.254975) + (perceptron_layer_2_output_7*0.298933) )
		perceptron_layer_3_output_1 = np.tanh( -0.296624 + (perceptron_layer_2_output_0*1.06632) + (perceptron_layer_2_output_1*0.0473234) + (perceptron_layer_2_output_2*-1.16081) + (perceptron_layer_2_output_3*-0.843293) + (perceptron_layer_2_output_4*-0.0817028) + (perceptron_layer_2_output_5*0.356062) + (perceptron_layer_2_output_6*0.10661) + (perceptron_layer_2_output_7*1.07239) )
		perceptron_layer_3_output_2 = np.tanh( -0.505932 + (perceptron_layer_2_output_0*0.752293) + (perceptron_layer_2_output_1*-0.5157) + (perceptron_layer_2_output_2*0.720654) + (perceptron_layer_2_output_3*-0.399773) + (perceptron_layer_2_output_4*-0.541422) + (perceptron_layer_2_output_5*-1.33296) + (perceptron_layer_2_output_6*-1.38192) + (perceptron_layer_2_output_7*0.177844) )
		perceptron_layer_3_output_3 = np.tanh( 0.652036 + (perceptron_layer_2_output_0*-1.73146) + (perceptron_layer_2_output_1*-0.0356777) + (perceptron_layer_2_output_2*-0.157847) + (perceptron_layer_2_output_3*0.656996) + (perceptron_layer_2_output_4*-0.240706) + (perceptron_layer_2_output_5*0.278818) + (perceptron_layer_2_output_6*0.693916) + (perceptron_layer_2_output_7*0.708988) )
		perceptron_layer_3_output_4 = np.tanh( -0.0850854 + (perceptron_layer_2_output_0*0.244714) + (perceptron_layer_2_output_1*0.458571) + (perceptron_layer_2_output_2*0.0866329) + (perceptron_layer_2_output_3*0.528672) + (perceptron_layer_2_output_4*-0.968059) + (perceptron_layer_2_output_5*1.20589) + (perceptron_layer_2_output_6*-0.571832) + (perceptron_layer_2_output_7*-0.724688) )
		perceptron_layer_3_output_5 = np.tanh( 0.0364166 + (perceptron_layer_2_output_0*-0.242741) + (perceptron_layer_2_output_1*0.298314) + (perceptron_layer_2_output_2*-1.3) + (perceptron_layer_2_output_3*0.642853) + (perceptron_layer_2_output_4*0.102813) + (perceptron_layer_2_output_5*0.290267) + (perceptron_layer_2_output_6*0.93367) + (perceptron_layer_2_output_7*-0.272648) )
		perceptron_layer_3_output_6 = np.tanh( -0.0301399 + (perceptron_layer_2_output_0*-0.628246) + (perceptron_layer_2_output_1*0.256201) + (perceptron_layer_2_output_2*-1.29742) + (perceptron_layer_2_output_3*0.250042) + (perceptron_layer_2_output_4*-0.589518) + (perceptron_layer_2_output_5*-0.375011) + (perceptron_layer_2_output_6*0.177086) + (perceptron_layer_2_output_7*1.74208) )
		perceptron_layer_3_output_7 = np.tanh( -0.227133 + (perceptron_layer_2_output_0*0.543614) + (perceptron_layer_2_output_1*1.31571) + (perceptron_layer_2_output_2*-1.08115) + (perceptron_layer_2_output_3*-0.203513) + (perceptron_layer_2_output_4*-0.258751) + (perceptron_layer_2_output_5*-0.551734) + (perceptron_layer_2_output_6*0.100174) + (perceptron_layer_2_output_7*0.570872) )
		
		perceptron_layer_4_output_0 = np.tanh( 0.321536 + (perceptron_layer_3_output_0*0.14631) + (perceptron_layer_3_output_1*-0.271798) + (perceptron_layer_3_output_2*0.00931437) + (perceptron_layer_3_output_3*0.377783) + (perceptron_layer_3_output_4*-0.59766) + (perceptron_layer_3_output_5*-0.00624017) + (perceptron_layer_3_output_6*0.0579984) + (perceptron_layer_3_output_7*-0.654336) )
		perceptron_layer_4_output_1 = np.tanh( -0.105443 + (perceptron_layer_3_output_0*1.04869) + (perceptron_layer_3_output_1*0.815355) + (perceptron_layer_3_output_2*-1.81036) + (perceptron_layer_3_output_3*1.10022) + (perceptron_layer_3_output_4*0.805674) + (perceptron_layer_3_output_5*1.63702) + (perceptron_layer_3_output_6*1.36408) + (perceptron_layer_3_output_7*-0.529819) )
		perceptron_layer_4_output_2 = np.tanh( 0.56768 + (perceptron_layer_3_output_0*-0.0602463) + (perceptron_layer_3_output_1*-0.243697) + (perceptron_layer_3_output_2*0.0922953) + (perceptron_layer_3_output_3*0.141416) + (perceptron_layer_3_output_4*-0.266444) + (perceptron_layer_3_output_5*-0.141879) + (perceptron_layer_3_output_6*-0.528463) + (perceptron_layer_3_output_7*0.159326) )
		perceptron_layer_4_output_3 = np.tanh( -0.101931 + (perceptron_layer_3_output_0*-0.0594098) + (perceptron_layer_3_output_1*-0.297969) + (perceptron_layer_3_output_2*-0.0820484) + (perceptron_layer_3_output_3*0.589509) + (perceptron_layer_3_output_4*-0.0955625) + (perceptron_layer_3_output_5*0.51694) + (perceptron_layer_3_output_6*0.0548782) + (perceptron_layer_3_output_7*-0.106105) )
		perceptron_layer_4_output_4 = np.tanh( -0.637338 + (perceptron_layer_3_output_0*0.486401) + (perceptron_layer_3_output_1*1.57829) + (perceptron_layer_3_output_2*-0.63473) + (perceptron_layer_3_output_3*-0.160934) + (perceptron_layer_3_output_4*-0.186721) + (perceptron_layer_3_output_5*0.629073) + (perceptron_layer_3_output_6*1.25408) + (perceptron_layer_3_output_7*1.32784) )
		perceptron_layer_4_output_5 = np.tanh( -0.35343 + (perceptron_layer_3_output_0*0.210927) + (perceptron_layer_3_output_1*0.109056) + (perceptron_layer_3_output_2*-0.0489305) + (perceptron_layer_3_output_3*-0.119444) + (perceptron_layer_3_output_4*0.222781) + (perceptron_layer_3_output_5*0.308549) + (perceptron_layer_3_output_6*0.467181) + (perceptron_layer_3_output_7*-0.447268) )
		perceptron_layer_4_output_6 = np.tanh( 0.549523 + (perceptron_layer_3_output_0*0.589667) + (perceptron_layer_3_output_1*0.0493733) + (perceptron_layer_3_output_2*-0.233405) + (perceptron_layer_3_output_3*0.740714) + (perceptron_layer_3_output_4*0.276045) + (perceptron_layer_3_output_5*0.0791745) + (perceptron_layer_3_output_6*0.636831) + (perceptron_layer_3_output_7*0.0333133) )
		perceptron_layer_4_output_7 = np.tanh( 0.912782 + (perceptron_layer_3_output_0*-0.603098) + (perceptron_layer_3_output_1*-1.18437) + (perceptron_layer_3_output_2*1.08979) + (perceptron_layer_3_output_3*-0.345464) + (perceptron_layer_3_output_4*1.0056) + (perceptron_layer_3_output_5*-0.373466) + (perceptron_layer_3_output_6*0.111653) + (perceptron_layer_3_output_7*0.294929) )
		
		perceptron_layer_5_output_0 = np.tanh( -0.683737 + (perceptron_layer_4_output_0*-0.193686) + (perceptron_layer_4_output_1*-0.0976591) + (perceptron_layer_4_output_2*-0.631374) + (perceptron_layer_4_output_3*0.167273) + (perceptron_layer_4_output_4*1.27175) + (perceptron_layer_4_output_5*0.6053) + (perceptron_layer_4_output_6*-0.425452) + (perceptron_layer_4_output_7*0.743822) )
		perceptron_layer_5_output_1 = np.tanh( 0.0513246 + (perceptron_layer_4_output_0*0.0519497) + (perceptron_layer_4_output_1*0.0190156) + (perceptron_layer_4_output_2*0.129771) + (perceptron_layer_4_output_3*0.19024) + (perceptron_layer_4_output_4*0.15045) + (perceptron_layer_4_output_5*-0.0177192) + (perceptron_layer_4_output_6*-0.142325) + (perceptron_layer_4_output_7*-0.059958) )
		perceptron_layer_5_output_2 = np.tanh( -0.190083 + (perceptron_layer_4_output_0*0.112265) + (perceptron_layer_4_output_1*0.187627) + (perceptron_layer_4_output_2*-0.138898) + (perceptron_layer_4_output_3*-0.165341) + (perceptron_layer_4_output_4*0.0677163) + (perceptron_layer_4_output_5*0.10017) + (perceptron_layer_4_output_6*0.0982105) + (perceptron_layer_4_output_7*0.105201) )
		perceptron_layer_5_output_3 = np.tanh( -0.0631299 + (perceptron_layer_4_output_0*0.591029) + (perceptron_layer_4_output_1*0.887089) + (perceptron_layer_4_output_2*0.00526612) + (perceptron_layer_4_output_3*0.332846) + (perceptron_layer_4_output_4*1.38094) + (perceptron_layer_4_output_5*0.0831626) + (perceptron_layer_4_output_6*-0.69132) + (perceptron_layer_4_output_7*0.121962) )
		perceptron_layer_5_output_4 = np.tanh( 0.279315 + (perceptron_layer_4_output_0*-0.144246) + (perceptron_layer_4_output_1*-0.595471) + (perceptron_layer_4_output_2*0.0379615) + (perceptron_layer_4_output_3*-0.142774) + (perceptron_layer_4_output_4*-0.26911) + (perceptron_layer_4_output_5*-0.284901) + (perceptron_layer_4_output_6*-0.250727) + (perceptron_layer_4_output_7*-0.100931) )
		perceptron_layer_5_output_5 = np.tanh( 0.00743855 + (perceptron_layer_4_output_0*0.0435791) + (perceptron_layer_4_output_1*0.154023) + (perceptron_layer_4_output_2*-0.00985702) + (perceptron_layer_4_output_3*-0.140451) + (perceptron_layer_4_output_4*0.0403246) + (perceptron_layer_4_output_5*0.00927431) + (perceptron_layer_4_output_6*0.074685) + (perceptron_layer_4_output_7*0.00346225) )
		perceptron_layer_5_output_6 = np.tanh( -0.0773581 + (perceptron_layer_4_output_0*0.388208) + (perceptron_layer_4_output_1*1.29677) + (perceptron_layer_4_output_2*0.0954059) + (perceptron_layer_4_output_3*0.390262) + (perceptron_layer_4_output_4*-0.652882) + (perceptron_layer_4_output_5*-0.137231) + (perceptron_layer_4_output_6*-0.608477) + (perceptron_layer_4_output_7*1.57571) )
		perceptron_layer_5_output_7 = np.tanh( -0.401858 + (perceptron_layer_4_output_0*0.151081) + (perceptron_layer_4_output_1*0.171318) + (perceptron_layer_4_output_2*-0.308747) + (perceptron_layer_4_output_3*0.0709525) + (perceptron_layer_4_output_4*0.81343) + (perceptron_layer_4_output_5*0.336638) + (perceptron_layer_4_output_6*-0.0118653) + (perceptron_layer_4_output_7*0.247872) )
		
		perceptron_layer_6_output_0 = ( -0.857818 + (perceptron_layer_5_output_0*-1.29258) + (perceptron_layer_5_output_1*-0.214808) + (perceptron_layer_5_output_2*0.0911571) + (perceptron_layer_5_output_3*-1.71956) + (perceptron_layer_5_output_4*0.312414) + (perceptron_layer_5_output_5*0.0489906) + (perceptron_layer_5_output_6*-1.9237) + (perceptron_layer_5_output_7*-0.540336) )
		
		unscaling_layer_output_0=perceptron_layer_6_output_0*14.00489998+44.70370102
		
		cs__two__eight_ = max(3.799999952, unscaling_layer_output_0)
		cs__two__eight_ = min(82.59999847, cs__two__eight_)
		
		out = [None]*1

		out[0] = cs__two__eight_

		return out


	def calculate_batch_output(self, input_batch):
		output_batch = [None]*input_batch.shape[0]

		for i in range(input_batch.shape[0]):

			inputs = list(input_batch[i])

			output = self.calculate_outputs(inputs)

			output_batch[i] = output

		return output_batch
